<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}
use  Google\AdsApi\AdWords\AdWordsServices ;
use  Google\AdsApi\AdWords\AdWordsSessionBuilder ;
use  Google\AdsApi\Common\OAuth2TokenBuilder ;
//WSKO_Class_Core::check_version(true);
class WSKO_AdminMenu
{
    static  $instance ;
    private  $wp_screen_prefix_nolevel = "admin_page_" ;
    private  $wp_screen_prefix_toplevel = "toplevel_page_" ;
    private  $wp_screen_prefix_sublevel = "bavoko-seo-tools_page_" ;
    public  $controller = null ;
    private  $controller_name = null ;
    private  $subpage_name = null ;
    private  $has_critical_errors = false ;
    public function __construct()
    {
        global  $pagenow ;
        if ( is_admin() ) {
            if ( WSKO_Class_Helper::check_user_permissions( false ) ) {
                
                if ( defined( 'DOING_AJAX' ) && DOING_AJAX ) {
                    //AJAX Controller
                    
                    if ( isset( $_POST['wsko_controller'] ) && $_POST['wsko_controller'] ) {
                        $this->get_controller( $_POST['wsko_controller'] );
                        
                        if ( $this->controller != null ) {
                            //Check for errors
                            $this->has_critical_errors = WSKO_Class_Core::get_critical_errors();
                            if ( !$this->has_critical_errors ) {
                                //Init Controller
                                $this->controller->set_subpage( ( isset( $_POST['wsko_controller_sub'] ) ? $_POST['wsko_controller_sub'] : '' ) );
                            }
                        }
                    
                    }
                
                } else {
                    //Backend Controllers
                    if ( $pagenow == 'admin.php' ) {
                        add_action( 'current_screen', array( $this, 'load_controller' ) );
                    }
                    add_action( 'admin_menu', array( $this, 'menu_items' ) );
                    add_action( 'add_meta_boxes', array( $this, 'add_meta_boxes' ) );
                    add_action( 'admin_enqueue_scripts', array( $this, 'load_scripts' ), 0 );
                    add_action( 'admin_enqueue_scripts', array( $this, 'load_scripts_third_party' ), 999999 );
                    add_action( 'admin_head', array( $this, 'admin_head' ) );
                    add_action( 'admin_footer', array( $this, 'admin_footer' ) );
                    add_filter(
                        'post_row_actions',
                        array( $this, 'add_content_optimizer_to_post_types' ),
                        10,
                        2
                    );
                    add_filter(
                        'page_row_actions',
                        array( $this, 'add_content_optimizer_to_post_types' ),
                        10,
                        2
                    );
                    $taxonomies = get_taxonomies( array(
                        'public' => true,
                    ), 'objects' );
                    if ( $taxonomies ) {
                        foreach ( $taxonomies as $tax ) {
                            add_action(
                                $tax->name . '_edit_form_fields',
                                array( $this, 'add_taxonomy_view' ),
                                500,
                                2
                            );
                        }
                    }
                    wsko_fs()->add_filter(
                        'templates/account.php',
                        array( $this, 'render_controller' ),
                        10,
                        1
                    );
                }
            
            }
        }
    }
    
    public function add_taxonomy_view( $term )
    {
        //$term = get_term($term->term_id);
        
        if ( $term ) {
            ?><tr class="form-field">
				<th scope="row" valign="top"><label>BAVOKO SEO Tools</label><p style="opacity:.7;">Metas & Social Snippets</p></th>
				<td>
					<div class="wsko-term-meta-widget wsko_wrapper">
						<ul class="wsko-nav bsu-tabs bsu-tabs-sm">
							<li><a class="wsko-nav-link wsko-nav-link-active" href="#wsko_tax_metas_general">Metas</a></li>
							<li><a class="wsko-nav-link" href="#wsko_tax_metas_social">Social</a></li>
						</ul>
						<div class="wsko-tab-content">
							<div id="wsko_tax_metas_general" class="wsko-tab wsko-tab-active">
								<?php 
            WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                'post_term' => $term->taxonomy . ':' . $term->term_id,
                'type'      => 'post_term',
                'meta_view' => 'metas',
            ) );
            ?>
							</div>
							<div id="wsko_tax_metas_social" class="wsko-tab">
								<?php 
            WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                'post_term' => $term->taxonomy . ':' . $term->term_id,
                'type'      => 'post_term',
                'meta_view' => 'social',
            ) );
            ?>
							</div>
						</div>
					</div>
				</td>
			</tr>
			<tr class="form-field">
				<th scope="row" valign="top"><p style="opacity:.7;">Canonical</p></th>
				<td>
					<?php 
            WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                'post_term' => $term->taxonomy . ':' . $term->term_id,
                'type'      => 'post_term',
                'meta_view' => 'canonical',
            ) );
            ?>
				</td>
			</tr><?php 
        }
    
    }
    
    public function add_content_optimizer_to_post_types( $actions, $post )
    {
        //if (!in_array($post->post_type, explode(',', WSKO_Class_Core::get_setting('content_optimizer_post_types_exclude'))))
        $actions['wsko_co'] = WSKO_Class_Template::render_content_optimizer_link( $post->ID );
        return $actions;
    }
    
    public function load_controller()
    {
        
        if ( is_admin() ) {
            $screen = get_current_screen();
            
            if ( $screen ) {
                $this->get_controller( $screen->id );
                
                if ( $this->controller != null ) {
                    //Check for errors
                    $this->has_critical_errors = WSKO_Class_Core::get_critical_errors();
                    
                    if ( !$this->has_critical_errors ) {
                        //Init Controller Rendering
                        $this->controller_name = $this->controller->get_link( false, true );
                        if ( $this->controller->set_subpage( ( isset( $_GET['subpage'] ) ? $_GET['subpage'] : '' ) ) ) {
                            $this->subpage_name = $this->controller->get_current_subpage();
                        }
                        $this->controller->redirect();
                    }
                
                } else {
                    if ( $this->get_controller( $screen->id, true, false ) ) {
                        
                        if ( WSKO_Class_Core::is_configured() ) {
                            wp_redirect( WSKO_Controller_Dashboard::get_link() );
                            exit;
                        } else {
                            wp_redirect( WSKO_Controller_Setup::get_link() );
                            exit;
                        }
                    
                    }
                }
            
            }
        
        }
    
    }
    
    public function menu_items()
    {
        $is_configured = WSKO_Class_Core::is_configured();
        $is_admin = current_user_can( 'manage_options' );
        
        if ( $is_configured ) {
            $hook = add_menu_page(
                WSKO_Controller_Dashboard::get_title_s( true, true ),
                'BAVOKO SEO Tools',
                //Dont change!!!
                'edit_posts',
                WSKO_Controller_Dashboard::get_link( false, true ),
                array( $this, 'render_controller' ),
                '',
                2
            );
            WSKO_Controller::add_wp_nav_links( array( $this, 'render_controller' ) );
        } else {
            
            if ( $is_admin ) {
                $hook = add_menu_page(
                    WSKO_Controller_Dashboard::get_title_s( true, false ),
                    'BAVOKO SEO Tools',
                    //Dont change!!!
                    'manage_options',
                    WSKO_Controller_Setup::get_link( false, true ),
                    array( $this, 'render_controller' ),
                    '',
                    2
                );
                WSKO_Controller::add_wp_nav_links( array( $this, 'render_controller' ) );
            }
        
        }
        
        $hook = add_submenu_page(
            null,
            WSKO_Controller_Download::get_title_s( true, true ),
            WSKO_Controller_Download::get_title_s(),
            'manage_options',
            WSKO_Controller_Download::get_link( false, true ),
            array( $this, 'render_controller' )
        );
        //TODO: remove
        $hook = add_submenu_page(
            null,
            'BAVOKO SEO Tools - Update',
            'Update',
            'edit_posts',
            'wsko_updated',
            array( $this, 'render_updated_page' )
        );
    }
    
    public function load_scripts( $hook )
    {
        if ( !in_array( $hook, array( 'edit.php', 'post.php', 'term.php' ) ) && !$this->controller ) {
            return;
        }
        global  $wsko_plugin_url, $wsko_plugin_path ;
        $script_data = array(
            'ajaxurl'                         => admin_url( 'admin-ajax.php' ),
            'mapsApiKey'                      => WSKO_GOOGLE_MAPS_API_KEY,
            'lazy_data_nonce'                 => wp_create_nonce( 'wsko_load_lazy_data' ),
            'add_monitoring_keyword_nonce'    => wp_create_nonce( 'wsko_add_monitoring_keyword' ),
            'remove_monitoring_keyword_nonce' => wp_create_nonce( 'wsko_remove_monitoring_keyword' ),
            'disavow_backlink_nonce'          => wp_create_nonce( 'wsko_disavow_backlink' ),
            'remove_disavowed_backlink_nonce' => wp_create_nonce( 'wsko_remove_disavowed_backlink' ),
            'knowledge_base_nonce'            => wp_create_nonce( 'wsko_get_knowledge_base_article' ),
            'is_configured'                   => WSKO_Class_Core::is_configured(),
            'template_no_data'                => WSKO_Class_Template::render_template( 'template-no-data.php', array(), true ),
            'save_ajax_input_nonce'           => wp_create_nonce( 'wsko_save_ajax_input' ),
        );
        $co_script_data = array(
            'content_optimizer_nonce' => wp_create_nonce( 'wsko_get_content_optimizer' ),
            'set_link_nonce'          => wp_create_nonce( 'wsko_co_set_link' ),
            'is_premium'              => wsko_fs()->can_use_premium_code() && wsko_fs()->is_premium(),
        );
        //Local
        wp_enqueue_script( 'jquery' );
        wp_enqueue_script( 'jquery-ui-core' );
        wp_enqueue_script( 'jquery-ui-draggable' );
        wp_enqueue_script( 'jquery-ui-droppable' );
        wp_enqueue_script( 'jquery-ui-sortable' );
        wp_enqueue_script( 'jquery-effects-core' );
        wp_enqueue_script( 'jquery-effects-fade' );
        wp_enqueue_script( 'jquery-effects-slide' );
        wp_enqueue_media();
        wp_enqueue_script( 'bloody_tinymce_js_main', includes_url() . 'js/tinymce/tinymce.min.js' );
        //WSKO JS
        wp_enqueue_script(
            'wsko_core_js',
            $wsko_plugin_url . 'admin/js/core.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'js',
            array(),
            WSKO_VERSION
        );
        wp_localize_script( 'wsko_core_js', 'wsko_data', $script_data );
        wp_enqueue_script(
            'wsko_co_js',
            $wsko_plugin_url . 'admin/js/post-widget.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'js',
            array(),
            WSKO_VERSION
        );
        wp_localize_script( 'wsko_core_js', 'wsko_co_data', $co_script_data );
        wp_enqueue_style( 'font_awesome', $wsko_plugin_url . 'includes/font-awesome/css/font-awesome.min.css' );
        wp_enqueue_style(
            'wsko_roboto',
            $wsko_plugin_url . 'admin/css/fonts.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_script( 'jquery_datatables', $wsko_plugin_url . 'includes/datatables/datatables.min.js' );
        //wp_enqueue_style('jquery_datatables_css', $wsko_plugin_url . 'includes/datatables/datatables.min.css');
        wp_enqueue_style( 'jquery_datatables_bootstrap', $wsko_plugin_url . 'includes/datatables/datatables.bootstrap.min.css' );
        wp_enqueue_script( 'jquery_datatables_bootstrap', $wsko_plugin_url . 'includes/datatables/datatables.bootstrap.min.js' );
        //Materialize
        wp_enqueue_script(
            'wsko_materialize',
            $wsko_plugin_url . 'includes/materialize/js/materialize.js',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_style(
            'wsko_materialize',
            $wsko_plugin_url . 'includes/materialize/css/materialize.css',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_script(
            'wsko_materialize_nouislider',
            $wsko_plugin_url . 'includes/materialize/extras/noUiSlider/nouislider.js',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_style(
            'wsko_materialize_nouislider',
            $wsko_plugin_url . 'includes/materialize/extras/noUiSlider/nouislider.css',
            array(),
            WSKO_VERSION
        );
        
        if ( $this->controller ) {
            //iTour
            wp_enqueue_script(
                'wsko_itour',
                $wsko_plugin_url . 'includes/iTour/js/jquery.itour.js',
                array(),
                WSKO_VERSION
            );
            wp_enqueue_style(
                'wsko_itour',
                $wsko_plugin_url . 'includes/iTour/css/itour.css',
                array(),
                WSKO_VERSION
            );
            //Sigma.js
            wp_enqueue_script(
                'wsko_sigma',
                $wsko_plugin_url . 'includes/sigma.js/sigma.min.js',
                array(),
                WSKO_VERSION
            );
            wp_enqueue_script(
                'wsko_sigma_atlas',
                $wsko_plugin_url . 'includes/sigma.js/plugins/sigma.layout.forceAtlas2.min.js',
                array(),
                WSKO_VERSION
            );
            //wp_enqueue_style('wsko_sigma', $wsko_plugin_url . 'includes/sigma.js/src/sigma.css', array(), WSKO_VERSION);
            $this->controller->enqueue_scripts();
        }
    
    }
    
    public function load_scripts_third_party( $hook )
    {
        if ( !in_array( $hook, array( 'edit.php', 'post.php', 'term.php' ) ) && !$this->controller ) {
            return;
        }
        global  $wsko_plugin_url ;
        $has_g_charts = false;
        //$has_materialize = false;
        $has_bootstrap_js = false;
        $has_bootstrap_css = false;
        $has_moment = false;
        $has_b_datepicker = false;
        $has_roboto = false;
        $wp_scripts = wp_scripts();
        $wp_styles = wp_styles();
        $bootstrap_override = false;
        if ( $this->controller ) {
            $bootstrap_override = true;
        }
        foreach ( $wp_scripts->registered as $handle => $data ) {
            if ( stripos( $data->src, 'plugins/wp-seo-keyword-optimizer/' ) !== false || stripos( $data->src, 'plugins/wsko/' ) !== false ) {
                continue;
            }
            if ( stripos( $data->src, 'gstatic.com/charts/loader.js' ) !== false ) {
                $has_g_charts = true;
            }
            //if (stripos($data->src, '/materialize.js') !== false || stripos($data->src, '/materialize.min.js') !== false)
            //$has_materialize = true;
            if ( stripos( $data->src, '/bootstrap.js' ) !== false || stripos( $data->src, '/bootstrap.min.js' ) !== false ) {
                
                if ( $bootstrap_override ) {
                    wp_deregister_script( $handle );
                } else {
                    $has_bootstrap_js = true;
                }
            
            }
            if ( stripos( $data->src, '/moment.js' ) !== false || stripos( $data->src, '/moment.min.js' ) !== false ) {
                $has_moment = true;
            }
            if ( stripos( $data->src, '/bootstrap-daterangepicker/' ) !== false ) {
                $has_b_datepicker = true;
            }
            //if (stripos($data->src, $wsko_plugin_url . 'admin/css/fonts.'.(WSKO_Class_Helper::is_dev()?'':'min.').'css') !== false)
            //$has_roboto = true;
        }
        foreach ( $wp_styles->registered as $handle => $data ) {
            if ( stripos( $data->src, 'plugins/wp-seo-keyword-optimizer/' ) !== false || stripos( $data->src, 'plugins/wsko/' ) !== false ) {
                continue;
            }
            if ( stripos( $data->src, '/bootstrap.css' ) !== false || stripos( $data->src, '/bootstrap.min.css' ) !== false ) {
                
                if ( $bootstrap_override ) {
                    wp_deregister_style( $handle );
                } else {
                    $has_bootstrap_css = true;
                }
            
            }
            if ( stripos( $data->src, '/bootstrap-daterangepicker/' ) !== false ) {
                $has_b_datepicker = true;
            }
            //if (stripos($data->src, $wsko_plugin_url . 'admin/css/fonts.'.(WSKO_Class_Helper::is_dev()?'':'min.').'css') !== false)
            //$has_roboto = true;
        }
        //WSKO CSS
        wp_enqueue_style(
            'wsko_core_css',
            $wsko_plugin_url . 'admin/css/core.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_style(
            'wsko_dashboard_css',
            $wsko_plugin_url . 'admin/css/dashboard.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_style(
            'wsko_freemius_css',
            $wsko_plugin_url . 'admin/css/freemius-style.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_style(
            'wsko_misc_css',
            $wsko_plugin_url . 'admin/css/misc.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_style(
            'wsko_post_wdiget_css',
            $wsko_plugin_url . 'admin/css/post-widget.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
        //CDN
        if ( !$has_g_charts ) {
            wp_enqueue_script( 'google_charts', 'https://www.gstatic.com/charts/loader.js' );
        }
        //3rd Party
        if ( !$has_bootstrap_js ) {
            wp_enqueue_script( 'bootstrap', $wsko_plugin_url . 'includes/bootstrap/js/bootstrap.min.js' );
        }
        if ( !$has_bootstrap_css ) {
            wp_enqueue_style( 'bootstrap', $wsko_plugin_url . 'includes/bootstrap/css/bootstrap.min.css' );
        }
        
        if ( $this->controller ) {
            if ( !$has_moment ) {
                wp_enqueue_script( 'moment', $wsko_plugin_url . 'includes/moment/moment.js' );
            }
            
            if ( !$has_b_datepicker ) {
                wp_enqueue_script( 'bootstrap_datepicker', $wsko_plugin_url . 'includes/bootstrap-daterangepicker/daterangepicker.js' );
                wp_enqueue_style( 'bootstrap_datepicker', $wsko_plugin_url . 'includes/bootstrap-daterangepicker/daterangepicker.css' );
            }
            
            //Roboto Font
            if ( !$has_roboto ) {
                wp_enqueue_style(
                    'wsko_roboto',
                    $wsko_plugin_url . 'admin/css/fonts.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
                    array(),
                    WSKO_VERSION
                );
            }
            $this->controller->enqueue_styles();
        }
        
        wp_enqueue_script(
            'bootstrap-select',
            $wsko_plugin_url . 'includes/bootstrap-select/js/bootstrap-select.min.js',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_style(
            'bootstrap-select',
            $wsko_plugin_url . 'includes/bootstrap-select/css/bootstrap-select.min.css',
            array(),
            WSKO_VERSION
        );
    }
    
    public function render_controller( $ext = false )
    {
        if ( $ext ) {
            ob_start();
        }
        
        if ( $this->controller || $ext ) {
            global  $wsko_plugin_path, $wsko_plugin_url ;
            
            if ( $this->has_critical_errors ) {
                ?><div id="wsko_admin_critical_error_wrapper" class="wsko-display-none-fix"><?php 
                global  $wp_version ;
                if ( isset( $this->has_critical_errors['incompatible_php'] ) && $this->has_critical_errors['incompatible_php'] ) {
                    WSKO_Class_Template::render_notification( 'error', array(
                        'msg'     => "You are running PHP " . (( PHP_VERSION ? PHP_VERSION : '(unversioned)' )) . ", which is not compatible with BAVOKO SEO Tools. We recommend you to update your PHP version to 7.x for a faster and more secure WordPress site!",
                        'subnote' => 'There are still WordPress plugins not working with PHP 7.x. If you can’t renounce them, you should at least update to PHP 5.6.',
                    ) );
                }
                if ( isset( $this->has_critical_errors['incompatible_wp'] ) && $this->has_critical_errors['incompatible_wp'] ) {
                    WSKO_Class_Template::render_notification( 'error', array(
                        'msg' => "You are running WP " . (( $wp_version ? $wp_version : '(unversioned)' )) . " which is not compatible with BAVOKO SEO Tools. We strongly recommend to update your WordPress!",
                    ) );
                }
                if ( isset( $this->has_critical_errors['content_dir_access'] ) && $this->has_critical_errors['content_dir_access'] ) {
                    WSKO_Class_Template::render_notification( 'error', array(
                        'msg'  => "Your Content Directory (" . WP_CONTENT_DIR . ") is not writable!",
                        'note' => "You can create a folder 'bst' in your content directory to skip this requirement.",
                    ) );
                }
                if ( isset( $this->has_critical_errors['bst_dir_access'] ) && $this->has_critical_errors['bst_dir_access'] ) {
                    WSKO_Class_Template::render_notification( 'error', array(
                        'msg'  => "BST can't access its folder 'bst' in your content directory (" . WP_CONTENT_DIR . ")!",
                        'list' => 'You will need to give write and read permission to WordPress on this folder.',
                    ) );
                }
                WSKO_Class_Template::render_notification( 'error', array(
                    'msg' => "Handle the error(s) above to gain access to the plugin",
                ) );
                ?></div><?php 
            } else {
                
                if ( !WSKO_Class_Core::is_configured() ) {
                    ?><div class="wsko-display-none-fix"><?php 
                    
                    if ( current_user_can( 'manage_options' ) ) {
                        
                        if ( !$ext ) {
                            $this->controller->view( false );
                            $this->controller->get_scripts( false );
                        } else {
                            echo  $ext ;
                        }
                        
                        global  $wsko_render_modals ;
                        $wsko_render_modals = true;
                    } else {
                        WSKO_Class_Template::render_notification( 'error', array(
                            'msg' => 'Only an Admin can setup the plugin!',
                        ) );
                    }
                    
                    ?></div><?php 
                } else {
                    
                    if ( $this->controller->has_main_frame ) {
                        global  $wsko_render_modals ;
                        $wsko_render_modals = true;
                        $breadcrump = ( !$ext ? $this->controller->get_breadcrump() : '' );
                        ?>
					<div id="wsko_admin_view_body" class="wsko_wrapper wsko-controller-view-<?php 
                        echo  $this->controller->link ;
                        ?> wsko-mobile-nav">
						<div id="wsko_admin_view_topbar">
							<div id="wsko_admin_view_topbar_icon" class="wsko_important_nav">
								<div class="wsko_logo" data-name="wsko_logo"><img class="" src="<?php 
                        echo  $wsko_plugin_url . 'admin/img/logo.png' ;
                        ?>" /></div> BAVOKO SEO Tools <!-- <small class="text-off" style="color:#fff;">RC</small> -->
							</div>
							<div id="wsko_admin_view_topbar_header">
								<div class="row">
									<div class="col-sm-6 col-xs-6">
										<span class="mobile-nav-toggle" style="display:none;"><a href="#" class="menu"><i class="fa fa-bars fa-fw fa-2x dark"></i></a></span>
										<div class="wsko-header-title-wrapper">
											<h2 id="wsko_main_title"><?php 
                        echo  $this->controller->get_title() ;
                        ?></h2>
											<span id="wsko_main_breadcrump"><?php 
                        echo  $breadcrump ;
                        ?></span>
										</div>
									</div>
									<div class="col-sm-6 col-xs-6">	
										<div id="wsko_admin_view_header_wrapper" class="wsko_header_meta_wrapper hidden-xs" style="padding:10px;">
											<div id="wsko_admin_view_timespan_wrapper">
												<?php 
                        if ( !$ext && $this->controller->uses_timespan( $this->controller->get_current_subpage() ) ) {
                            WSKO_Class_Template::render_timespan_widget();
                        }
                        ?>
											</div>
											<?php 
                        $this->controller->get_header_widget();
                        ?>
										</div>
									</div>
								</div>		
							</div>
						</div>
						<div id="wsko_admin_view_sidebar" class="wsko_important_nav">
							<div id="wsko_admin_view_sidebar_overlay" class="wsko-admin-main-navbar">
								<?php 
                        $controllers = WSKO_Controller::get_main_nav_controllers();
                        WSKO_Class_Template::render_main_navigation( $controllers, ( !$ext ? $this->controller_name : '' ), ( !$ext ? $this->subpage_name : '' ) );
                        ?>	

								<div class="wsko-sidebar-info-links">
									<ul>
										<?php 
                        
                        if ( current_user_can( 'manage_options' ) ) {
                            ?>
											<li><a class="wsko-white wsko-upgrade-now" href="<?php 
                            echo  wsko_fs()->pricing_url() ;
                            ?>"><i class="fa fa-rocket fa-fw mr3"></i>Upgrade</a></li>
											<?php 
                            
                            if ( WSKO_Class_Core::has_account() ) {
                                ?>
												<li><a class="wsko-white" href="<?php 
                                echo  wsko_fs()->get_account_url() ;
                                ?>"><i class="fa fa-user fa-fw mr3"></i>Account</a></li>
											<?php 
                            }
                            
                            ?>
										<?php 
                        }
                        
                        ?>
										<li class="hidden-xs"><a class="wsko-white wsko-toggle-help"><i class="fa fa-question fa-fw mr3"></i>Help</a></li>
									</ul>	
								</div>					
							</div>						
							
						</div>
						<div id="wsko_admin_view_content">
							<div id="wsko_admin_view_ajax_notification"></div>
							<div id="wsko_admin_view_content_wrapper">
								<div id="wsko_notification_wrapper">
									<div id="wsko_admin_view_notification_wrapper" style="margin: auto 20px;">
										<?php 
                        if ( !$ext ) {
                            $this->controller->notifications();
                        }
                        ?>
									</div>
									<div class="wsko_notification" id="wsko_admin_ajax_notifications"></div>
								</div>	
								
								<div id="wsko_admin_view_wrapper">
									<?php 
                        
                        if ( !$ext ) {
                            $this->controller->view( false );
                        } else {
                            echo  $ext ;
                        }
                        
                        ?>
								</div>
								
								<div id="wsko_admin_view_loading">
									<div id="wsko_admin_view_loading_background"></div>
									<?php 
                        echo  WSKO_Class_Template::render_preloader( array(
                            'size' => 'big',
                        ) ) ;
                        ?> 
								</div>
							</div>

							<?php 
                        WSKO_Class_Template::render_template( 'modal-help.php', array(
                            'breadcrump' => $breadcrump,
                        ) );
                        ?>

							<p class="hidden-xs wsko-made-in">Made with <i class="fa fa-heart fa-fw"></i> in Berlin, Germany</p>			
							<?php 
                        //WSKO_Class_Template::render_template('misc/template-nps-score.php', array());
                        ?>
						</div>
					</div>
					
					<div id="wsko_admin_view_script_wrapper">
						<?php 
                        if ( !$ext ) {
                            $this->controller->get_scripts( false );
                        }
                        ?>
					</div><?php 
                    } else {
                        $this->controller->view( false );
                        $this->controller->get_scripts( false );
                    }
                
                }
            
            }
        
        } else {
            ?><div class="wsko-display-none-fix"><?php 
            WSKO_Class_Template::render_notification( 'error', array(
                'msg' => 'Controller could not be loaded!',
            ) );
            ?></div><?php 
        }
        
        if ( $ext ) {
            return ob_get_clean();
        }
    }
    
    public function render_updated_page()
    {
        WSKO_Class_Template::render_template( 'misc/frame-info.php', array() );
    }
    
    public function add_meta_boxes()
    {
        
        if ( WSKO_Class_Core::get_setting( 'activate_content_optimizer' ) ) {
            $wsko_post_types = get_post_types( array(), 'names' );
            $wsko_post_types_ex = explode( ',', WSKO_Class_Core::get_setting( 'content_optimizer_post_types_exclude' ) );
            foreach ( $wsko_post_types as $type ) {
                if ( !$wsko_post_types_ex || !in_array( $type, $wsko_post_types_ex ) ) {
                    add_meta_box(
                        'wsko_post_metabox',
                        'BAVOKO SEO Tools',
                        array( &$this, 'post_meta_box_view' ),
                        $type,
                        'normal',
                        'high'
                    );
                }
            }
        }
    
    }
    
    public function post_meta_box_view()
    {
        global  $pagenow ;
        
        if ( $pagenow != 'post.php' ) {
            ?><p>Content Optimizer is available after first save.</p><?php 
            return;
        }
        
        global  $post, $wsko_plugin_url ;
        
        if ( $post ) {
            $is_gutenberg = function_exists( 'is_gutenberg_page' ) && is_gutenberg_page();
            ?><script type="text/javascript">
				jQuery(document).ready(function($){
					<?php 
            
            if ( WSKO_Class_Core::get_user_setting( 'unstick_content_optimizer' ) || is_plugin_active( 'js_composer/js_composer.php' ) && get_post_meta( $post->ID, '_wpb_vc_js_status', true ) || is_plugin_active( 'fusion-builder/fusion-builder.php' ) && FusionBuilder::get_instance()->allowed_post_types() && in_array( $post->post_type, FusionBuilder::get_instance()->allowed_post_types() ) || class_exists( 'Avia_Builder' ) && 'active' == Avia_Builder::instance()->get_alb_builder_status( $post->ID ) || function_exists( 'et_builder_enabled_for_post' ) && et_builder_enabled_for_post( $post->ID ) ) {
                //Divi Builder
                ?>$('#wsko_post_metabox').addClass('wsko-metabox-vc').insertAfter('#titlediv');<?php 
            } else {
                ?>$('#wsko_post_metabox').insertBefore('#wp-content-media-buttons');<?php 
            }
            
            ?>
					$('#wsko_post_metabox h2.hndle span').prepend('<div class="wsko_mini_logo"><img src="<?php 
            echo  $wsko_plugin_url . 'admin/img/logo.png' ;
            ?>"></div>');
					var changeTimout,
					post_title,
					post_content,
					post_slug;
					jQuery.wsko_reload_content_optimizer = function()
					{
						if (changeTimout)
							clearTimeout(changeTimout);
						
						changeTimout = setTimeout(function(){
							$('#wsko_content_optimizer_ajax_reload_overlay').show();
							var was_open = $('.wsko-co-widget').length && !$('.wsko-co-widget').hasClass('wsko-short-view-active');
							jQuery.wsko_post_element({action: 'wsko_get_content_optimizer', post: <?php 
            echo  $post->ID ;
            ?>, widget:true, preview:((post_title||post_content||post_slug) ? true : false), post_title: post_title, post_content:post_content, post_slug:post_slug ,nonce: wsko_co_data.content_optimizer_nonce}, 
								function(res){
									$('#wsko_content_optimizer_ajax_reload_overlay').hide();
									if (res.success)
									{
										$('#wsko_content_optimizer_ajax_reload_wrapper').html(res.view);
										if (was_open)
										{
											$('.wsko-co-widget').removeClass('wsko-short-view-active');
										}
										return true;
									}
									else
									{
										$('#wsko_content_optimizer_ajax_reload_wrapper').html("Content Optimizer could not be generated. Please try again");
									}
								},
								function()
								{
									$('#wsko_content_optimizer_ajax_reload_wrapper').html("A Server Error occured. Please try again.");
									$('#wsko_content_optimizer_ajax_reload_overlay').hide();
								}, false, false);
						}, 1000);
					}
					$('#titlewrap input[name="post_title"]').change(function(){
						post_title = $(this).val();
						jQuery.wsko_reload_content_optimizer();
					});
					$('#wp-content-editor-container .wp-editor-area').change(function(){
						post_content = $(this).val();
						jQuery.wsko_reload_content_optimizer();
					});
					$('#edit-slug-buttons .save.button').click(function(event){
						post_slug = $('#editable-post-name').text();
						jQuery.wsko_reload_content_optimizer();
					});

					<?php 
            
            if ( $is_gutenberg ) {
                ?>
					var el = wp.element.createElement;
					var Fragment = wp.element.Fragment;
					var PluginSidebar = wp.editPost.PluginSidebar;
					var PluginSidebarMoreMenuItem = wp.editPost.PluginSidebarMoreMenuItem;
					var registerPlugin = wp.plugins.registerPlugin;

					var sidebarEl = el('div', { id: "wsko_content_optimizer_ajax_reload_overlay", style: "position:absolute;top:0px;left:0px;width:100%;height:100%;background-color:white;text-align:center;padding-top:10px;z-index:99;display:none;" },
						el('i', { className: "fa fa-spinner fa-pulse" })
					);
					function wsko_to_widget_link_event(event)
					{
						event.preventDefault();
						$([document.documentElement, document.body, $('.edit-post-layout__content').get(0)]).animate({
							scrollTop: $("#wsko_post_metabox").offset().top
						}, 2000);
					}
					function Component() {
						return el(
							Fragment,
							{},
							el(
								PluginSidebarMoreMenuItem,
								{
									target: 'wsko-co-gutenberg-sidebar',
								},
								'BAVOKO SEO Tools'
							),
							el(
								PluginSidebar,
								{
									name: 'wsko-co-gutenberg-sidebar',
									title: 'BAVOKO SEO Tools',
								},
								el('div', {},
									 'Gutenberg integration coming soon...',
									 el('br', {}),
									 el('a', {href: "#", onClick: wsko_to_widget_link_event}, 'To Widget')
								)
							)
						);
					}
					var iconEl = el('img', { src: "<?php 
                echo  $wsko_plugin_url ;
                ?>admin/img/logo-bl-sm.png" });
					registerPlugin('wsko-co', {
						icon: iconEl,
						render: Component,
					});
					jQuery.wsko_reload_content_optimizer();
					<?php 
            } else {
                ?>
						setTimeout(function(){ //late bind tinymce
							for (var i = 0; i < tinymce.editors.length; i++) {
								tinymce.editors[i].onChange.add(function (ed, e) {
									post_content = ed.getContent();
									jQuery.wsko_reload_content_optimizer();
								});
							}
							jQuery.wsko_reload_content_optimizer();
						}, 1000);
					<?php 
            }
            
            ?>
				});
			</script>
			
			<div id="wsko_content_optimizer_ajax_reload_wrapper">
				<?php 
            //echo WSKO_Controller_Optimizer::render($post->ID, true);
            ?>
			</div>

			<div id="wsko_content_optimizer_ajax_reload_overlay" style="position:absolute;top:0px;left:0px;width:100%;height:100%;background-color:white;text-align:center;padding-top:10px;z-index:99;display:none;">
				<i class="fa fa-spinner fa-pulse"></i> Loading
			</div>
			<?php 
        }
    
    }
    
    public function admin_head()
    {
        
        if ( WSKO_Class_Core::is_opted_in() ) {
            ?><script type="text/javascript">
			(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
				(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
				m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
				})(window,document,'script','https://www.google-analytics.com/analytics.js','ga');
			ga('create', 'UA-64850400-8', 'auto', 'wskoTracker');
			ga('wskoTracker.set', 'appName', 'BAVOKO SEO Tools');
			ga('wskoTracker.set', 'appId', 'bst');
			ga('wskoTracker.set', 'appVersion', '<?php 
            echo  WSKO_VERSION ;
            ?>');
			</script><?php 
        }
    
    }
    
    public function admin_footer()
    {
        /*global $post, $pagenow;
        		if ($pagenow != 'post.php')
        			return;*/
        WSKO_Class_Template::render_template( 'content-optimizer/modal-content-optimizer.php', array() );
        WSKO_Class_Template::render_template( 'knowledge/modal-knowledge-base-article.php', array() );
        global  $wsko_render_modals ;
        
        if ( $wsko_render_modals ) {
            //is plugin page
            WSKO_Class_Template::render_template( 'modal-general.php', array() );
            WSKO_Class_Template::render_template( 'modal-feedback.php', array() );
        }
    
    }
    
    public function get_controller( $name, $switched = false, $set = true )
    {
        $contr = null;
        $name_p = explode( 'wsko_', $name );
        $contr_n = end( $name_p );
        if ( $res = WSKO_Controller::get_registered_controller( $contr_n, $switched ) ) {
            $contr = $res;
        }
        if ( $set ) {
            $this->controller = $contr;
        }
        return $contr;
    }
    
    /*Singleton*/
    public static function get_instance()
    {
        if ( !isset( self::$instance ) ) {
            self::$instance = new self();
        }
        return self::$instance;
    }

}