<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}
class WSKO_Controller
{
    /*Options*/
    //string
    public  $icon = "" ;
    //string
    public  $link = "" ;
    //array
    public  $subpages = array() ;
    //array
    public  $subpages_ext = array() ;
    //array
    public  $scripts = array() ;
    //array
    public  $styles = array() ;
    //array
    public  $ajax_actions = array() ;
    //string
    public  $template_folder = "" ;
    //string
    /*public $template_main = "";
    	//string
    	public $template_header = "";
    	//string
    	public $template_notifications = "";
    	//string
    	public $template_footer = "";*/
    //bool
    public  $is_main = false ;
    //bool
    public  $show_in_setup = false ;
    //bool
    public  $admin_only = false ;
    //bool
    public  $is_real_page = true ;
    //bool
    public  $is_invisible_page = false ;
    //int
    public  $nav_prio = 0 ;
    //bool
    public  $has_main_nav_link = true ;
    //bool
    public  $has_main_frame = true ;
    //array
    public  $tour = array() ;
    /*/*/
    public  $subpage ;
    public static  $main_controller = null ;
    public static  $controllers = array() ;
    /*Controls*/
    public static function init_controller( $add = true )
    {
        $inst = static::get_instance();
        $inst->add_actions();
        if ( $add ) {
            static::$controllers[] = $inst;
        }
        if ( !static::$main_controller ) {
            static::$main_controller = $inst;
        }
    }
    
    public function add_actions()
    {
        if ( !has_action( 'wp_ajax_wsko_get_attachment_popup' ) ) {
            add_action( 'wp_ajax_wsko_get_attachment_popup', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_load_lazy_data' ) ) {
            add_action( 'wp_ajax_wsko_load_lazy_data', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_load_lazy_page' ) ) {
            add_action( 'wp_ajax_wsko_load_lazy_page', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_get_help_content' ) ) {
            add_action( 'wp_ajax_wsko_get_help_content', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_set_timespan' ) ) {
            add_action( 'wp_ajax_wsko_set_timespan', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_reset_timespan' ) ) {
            add_action( 'wp_ajax_wsko_reset_timespan', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_save_ajax_input' ) ) {
            add_action( 'wp_ajax_wsko_save_ajax_input', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_resolve_url' ) ) {
            add_action( 'wp_ajax_wsko_resolve_url', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_get_content_optimizer' ) ) {
            add_action( 'wp_ajax_wsko_get_content_optimizer', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_import_plugin' ) ) {
            add_action( 'wp_ajax_wsko_import_plugin', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_send_feedback' ) ) {
            add_action( 'wp_ajax_wsko_send_feedback', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_send_nps_feedback' ) ) {
            add_action( 'wp_ajax_wsko_send_nps_feedback', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_skip_nps_feedback' ) ) {
            add_action( 'wp_ajax_wsko_skip_nps_feedback', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_discard_notice' ) ) {
            add_action( 'wp_ajax_wsko_discard_notice', array( $this, 'handle_action' ) );
        }
        if ( !has_action( 'wp_ajax_wsko_controller_tour_ended' ) ) {
            add_action( 'wp_ajax_wsko_controller_tour_ended', array( $this, 'handle_action' ) );
        }
        if ( $this->ajax_actions ) {
            foreach ( $this->ajax_actions as $action ) {
                if ( !has_action( 'wp_ajax_wsko_' . $action ) ) {
                    add_action( 'wp_ajax_wsko_' . $action, array( $this, 'handle_action' ) );
                }
            }
        }
    }
    
    public function handle_action()
    {
        $action = sanitize_text_field( $_POST['action'] );
        $action = substr( $action, strlen( 'wsko_' ), strlen( $action ) );
        $func = 'action_' . $action;
        
        if ( method_exists( $this, $func ) ) {
            $res = $this->{$func}();
            
            if ( $res === true ) {
                wp_send_json( array(
                    'success' => true,
                ) );
                wp_die();
            } else {
                
                if ( !$res && !is_array( $res ) ) {
                    
                    if ( defined( 'WSKO_DEMO_SWITCH' ) && WSKO_DEMO_SWITCH ) {
                        wp_send_json( array(
                            'success' => false,
                            'msg'     => 'Please note: Editing is disabled in the Demo',
                        ) );
                        wp_die();
                    } else {
                        wp_send_json( array(
                            'success' => false,
                        ) );
                        wp_die();
                    }
                
                } else {
                    wp_send_json( $res );
                    wp_die();
                }
            
            }
        
        }
        
        wp_send_json( array(
            'success' => false,
        ) );
        wp_die();
    }
    
    public function can_execute_action( $high_cap = true, $no_ajax = false )
    {
        
        if ( $no_ajax ) {
            if ( WSKO_Class_Helper::check_user_permissions( $high_cap ) ) {
                return true;
            }
        } else {
            $real_action = sanitize_text_field( $_POST['action'] );
            
            if ( defined( 'DOING_AJAX' ) && DOING_AJAX && $real_action && substr( $real_action, 0, strlen( 'wsko_' ) ) == 'wsko_' ) {
                $action = substr( $real_action, strlen( 'wsko_' ), strlen( $real_action ) );
                if ( $action && ($this->ajax_actions && in_array( $action, $this->ajax_actions ) || in_array( $action, array(
                    'get_attachment_popup',
                    'load_lazy_data',
                    'load_lazy_page',
                    'get_help_content',
                    'set_timespan',
                    'reset_timespan',
                    'save_ajax_input',
                    'resolve_url',
                    'get_content_optimizer',
                    'import_plugin',
                    'send_feedback',
                    'send_nps_feedback',
                    'skip_nps_feedback',
                    'discard_notice',
                    'controller_tour_ended'
                ) )) ) {
                    if ( WSKO_Class_Helper::check_user_permissions( $high_cap ) ) {
                        if ( wp_verify_nonce( $_POST['nonce'], $real_action ) ) {
                            return true;
                        }
                    }
                }
            }
        
        }
        
        return false;
    }
    
    public function add_menu_page( $callback )
    {
        $is_configured = WSKO_Class_Core::is_configured();
        if ( $this->is_real_page && static::$main_controller ) {
            $hook = add_submenu_page(
                ( !$this->is_invisible_page && ($is_configured && !$this->show_in_setup || !$is_configured && $this->show_in_setup) ? static::$main_controller->get_link( false, true ) : null ),
                static::get_title_s( true, true ),
                static::get_title_s(),
                ( $this->admin_only ? 'manage_options' : 'edit_posts' ),
                static::get_link( false, true ),
                $callback
            );
        }
    }
    
    public function set_subpage( $page )
    {
        $subpages = $this->get_subpages();
        
        if ( !$page && $subpages && is_array( $subpages ) ) {
            reset( $subpages );
            $page = key( $subpages );
        }
        
        
        if ( $page && $subpages && is_array( $subpages ) && isset( $subpages[$page] ) ) {
            $this->subpage = array(
                'key' => $page,
            ) + $subpages[$page];
            return true;
        }
        
        return false;
    }
    
    public function get_current_subpage( $return_obj = false )
    {
        $subpages = $this->get_subpages();
        
        if ( $subpages && is_array( $subpages ) ) {
            $subpage = $this->subpage;
            
            if ( !$subpage ) {
                reset( $subpages );
                $key = key( $subpages );
                $subpage = $subpages[$key];
            }
            
            if ( $subpage ) {
                return ( $return_obj ? $subpage : $subpage['key'] );
            }
        }
        
        return false;
    }
    
    /*/*/
    /*View*/
    public function redirect()
    {
        //abstract
    }
    
    public function get_title()
    {
        //abstract
        return 'No Title';
        //$this->title;
    }
    
    public function get_subpage_title( $subpage )
    {
        //abstract
        return 'No Title';
    }
    
    public function get_breadcrump()
    {
        $breadcrump = $this->get_breadcrump_title();
        
        if ( $breadcrump ) {
            return $breadcrump;
        } else {
            if ( $this->subpage && is_array( $this->subpage ) ) {
                return $this->get_title() . " <i class='fa fa-angle-right fa-fw'></i> " . $this->get_subpage_title( $this->subpage['key'] );
            }
        }
        
        return "";
    }
    
    public function get_breadcrump_title()
    {
        return false;
    }
    
    public function enqueue_scripts()
    {
        global  $wsko_plugin_url ;
        $times = $this->get_cached_var( 'timespan', true );
        $script_data = array(
            'ajaxurl'                => admin_url( 'admin-ajax.php' ),
            'controller'             => $this->get_link( false, true ),
            'subpage'                => ( $this->subpage ? $this->subpage['key'] : '' ),
            'timespan_start'         => $times['start'],
            'timespan_end'           => $times['end'],
            'get_help_content_nonce' => wp_create_nonce( 'wsko_get_help_content' ),
            'save_ajax_input_nonce'  => wp_create_nonce( 'wsko_save_ajax_input' ),
            'ssl_enabled'            => WSKO_Class_Helper::ssl_enabled(),
        );
        wp_enqueue_script(
            'wsko_admin_js',
            $wsko_plugin_url . 'admin/js/admin.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'js',
            array(),
            WSKO_VERSION
        );
        wp_localize_script( 'wsko_admin_js', 'wsko_admin_data', $script_data );
        wp_enqueue_script(
            'wsko_kb_js',
            $wsko_plugin_url . 'admin/js/knowledge-base.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'js',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_script(
            'wsko_misc_js',
            $wsko_plugin_url . 'admin/js/misc.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'js',
            array(),
            WSKO_VERSION
        );
    }
    
    public function enqueue_styles()
    {
        global  $wsko_plugin_url ;
        wp_enqueue_style(
            'wsko_old_admin_css',
            $wsko_plugin_url . 'admin/css/old-admin.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
        //TODO: remove
        wp_enqueue_style(
            'wsko_admin_css',
            $wsko_plugin_url . 'admin/css/admin.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_style(
            'wsko_kb_css',
            $wsko_plugin_url . 'admin/css/knowledge.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_style(
            'wsko_responsive_css',
            $wsko_plugin_url . 'admin/css/responsive.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
        wp_enqueue_style(
            'wsko_normalize_css',
            $wsko_plugin_url . 'admin/css/normalize.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css',
            array(),
            WSKO_VERSION
        );
    }
    
    public function notifications( $return = false )
    {
        if ( $return ) {
            ob_start();
        }
        /*if (isset($wsko_data['timeout_check']) && $wsko_data['timeout_check'] > (time() + WSKO_LRS_TIMEOUT))
        		{
        			$wsko_data = WSKO_Class_Core::get_data();
        			WSKO_Class_Template::render_notification('warning', array('msg' => "The Timeout Check has not been finished (Started at ".date('d.m.Y h:i', $wsko_data['timeout_check'])."). Cache updates can be very time consuming and exceeding the time limit will result in corrupted datasets and errors when updating manually. Please contact your Administrator to raise the script execution time limit to ".round(WSKO_LRS_TIMEOUT/60)." minutes (".WSKO_LRS_TIMEOUT." seconds).", 'subnote' => 'Next Check at '.date('d.m.Y h:i', wp_next_scheduled('wsko_check_timeout'))));
        		}*/
        WSKO_Class_Template::render_template( 'template-global-notifications.php', array() );
        if ( $this->template_folder ) {
            WSKO_Class_Template::render_template( $this->template_folder . '/notifications.php', array(), false );
        }
        if ( $return ) {
            return ob_get_clean();
        }
    }
    
    public function get_header_widget( $return = false )
    {
        if ( $return ) {
            ob_start();
        }
        global  $wsko_plugin_path ;
        if ( $this->template_folder ) {
            WSKO_Class_Template::render_template( $this->template_folder . '/header.php', array(
                'subpage' => $this->get_current_subpage( false ),
            ), false );
        }
        if ( $return ) {
            return ob_get_clean();
        }
    }
    
    public function view( $widget = false, $return = false )
    {
        if ( $return ) {
            ob_start();
        }
        global  $wsko_plugin_path ;
        
        if ( $this->template_folder ) {
            $inst = static::get_instance();
            $subpage = $inst->get_current_subpage();
            
            if ( $inst->is_accessible( $subpage ) ) {
                
                if ( WSKO_Class_Template::template_exists( $this->template_folder . '/frame.php' ) ) {
                    WSKO_Class_Template::render_template( $this->template_folder . '/frame.php', array(
                        'widget' => $widget,
                    ) );
                } else {
                    $inst->subpage_view( $widget );
                }
            
            } else {
                WSKO_Class_Template::render_template( $this->template_folder . '/frame-empty.php', array(
                    'widget'  => $widget,
                    'subpage' => $subpage,
                ) );
            }
        
        }
        
        if ( $return ) {
            return ob_get_clean();
        }
    }
    
    public function subpage_view( $widget = false, $return = false )
    {
        if ( $return ) {
            ob_start();
        }
        global  $wsko_plugin_path ;
        $subpages = $this->get_subpages();
        
        if ( $subpages && is_array( $subpages ) ) {
            $subpage = $this->get_current_subpage( true );
            if ( $subpage ) {
                WSKO_Class_Template::render_template( $subpage['template'], array(
                    'controller' => $this,
                    'widget'     => $widget,
                ) );
            }
        }
        
        if ( $return ) {
            return ob_get_clean();
        }
    }
    
    public function content_footer( $return = false )
    {
        if ( $return ) {
            ob_start();
        }
        global  $wsko_plugin_path ;
        if ( $this->template_folder ) {
            WSKO_Class_Template::render_template( $this->template_folder . '/footer.php', array(), false );
        }
        if ( $return ) {
            return ob_get_clean();
        }
    }
    
    public function get_scripts( $widget = false, $return = false )
    {
        if ( $return ) {
            ob_start();
        }
        
        if ( !$widget ) {
            $inst = static::get_instance();
            ?><script type="text/javascript" >
			<?php 
            if ( WSKO_Class_Core::is_opted_in() ) {
                
                if ( $inst && $inst->link ) {
                    $subpage = $inst->get_current_subpage();
                    $page = '/' . $inst->link . (( $subpage ? '/' . $subpage : '' ));
                    ?>ga('wskoTracker.set', 'page', '<?php 
                    echo  $page ;
                    ?>');
						ga('wskoTracker.set', 'screenName', '<?php 
                    echo  $page ;
                    ?>');
						ga('wskoTracker.send', 'screenview');
						ga('wskoTracker.send', 'pageview');<?php 
                }
            
            }
            ?>
			jQuery(document).ready(function($){
				wsko_admin_data.timespan_nonce = '<?php 
            echo  wp_create_nonce( 'wsko_set_timespan' ) ;
            ?>';
				wsko_admin_data.resolve_nonce = '<?php 
            echo  wp_create_nonce( 'wsko_resolve_url' ) ;
            ?>';
				wsko_admin_data.lazy_page_nonce = '<?php 
            echo  wp_create_nonce( 'wsko_load_lazy_page' ) ;
            ?>';
				wsko_admin_data.get_attachment_popup_nonce = '<?php 
            echo  wp_create_nonce( 'wsko_get_attachment_popup' ) ;
            ?>';
				wsko_admin_data.get_help_content_nonce = '<?php 
            echo  wp_create_nonce( 'wsko_get_help_content' ) ;
            ?>';
				wsko_admin_data.save_ajax_input_nonce = '<?php 
            echo  wp_create_nonce( 'wsko_save_ajax_input' ) ;
            ?>';
				wsko_admin_data.feedback_nonce = '<?php 
            echo  wp_create_nonce( 'wsko_send_feedback' ) ;
            ?>';
			});
			</script><?php 
        }
        
        global  $wsko_plugin_url ;
        if ( $this->scripts && is_array( $this->scripts ) ) {
            foreach ( $this->scripts as $script ) {
                ?><script type="text/javascript" src="<?php 
                echo  $wsko_plugin_url . 'admin/js/' . $script . '.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'js?ver=' . WSKO_VERSION ;
                ?>"></script><?php 
            }
        }
        if ( $this->styles && is_array( $this->styles ) ) {
            foreach ( $this->styles as $style ) {
                ?><link href="<?php 
                echo  $wsko_plugin_url . 'admin/css/' . $style . '.' . (( WSKO_Class_Helper::is_dev() ? '' : 'min.' )) . 'css?ver=' . WSKO_VERSION ;
                ?>" rel="stylesheet" type="text/css"></link><?php 
            }
        }
        
        if ( !$widget ) {
            ?><script type="text/javascript">
			jQuery(document).ready(function($){
				jQuery.wsko_load_lazy_data($('#wsko_admin_view_content_wrapper'), 'page_data', false, false);
				<?php 
            if ( $this->uses_timespan ) {
                ?> 
				$(document).on("wsko_event_timespan_set", function(e){
					jQuery.wsko_load_lazy_data($('#wsko_admin_view_content_wrapper'), 'page_data', false, true);
				});
				<?php 
            }
            ?>
				jQuery.wsko_init_admin();
				<?php 
            $this->render_js_tour( false );
            ?>
			});
			</script><?php 
        }
        
        if ( $return ) {
            return ob_get_clean();
        }
    }
    
    public function render_js_tour( $return = false )
    {
        if ( $return ) {
            ob_start();
        }
        $tour = $this->build_js_tour();
        ?>
		jQuery.wsko_open_controller_tour = function()
		{ 
			<?php 
        /*if ($tour) { //TODO: Tour ?>
        				$('body').itour({
        					tourTitle:'<?=$tour['title']?>',
        					<?=isset($tour['intro']) && $tour['intro'] ? 'introShow:true,' : ''?>
        					<?=isset($tour['intro_cover']) && $tour['intro_cover'] ? 'introCover:"'.$tour['intro_cover'].'",' : ''?>
        					<?=isset($tour['hide_map']) && $tour['hide_map'] ? '' : 'tourMapVisible:true,'?>
        					steps:[
        						<?php foreach ($tour['steps'] as $step)
        						{
        							?>{
        								title: '<?=$step['title']?>',
        								content: '<?=$step['content']?>',
        								name: '<?=$step['data_name']?>',
        							},<?php
        						} ?>],
        					end: function(){
        						jQuery.wsko_post_element({action:'wsko_controller_tour_ended', tour:'<?=$tour['name']?>', nonce: '<?=wp_create_nonce('wsko_controller_tour_ended')?>'}, function(res){ return true; }, function(){ return true; }, false, false);
        					}
        				});
        			<?php
        		}*/
        ?>
		
			<?php 
        
        if ( WSKO_Class_Core::is_configured() ) {
            $co_post = WSKO_Class_Helper::url_to_postid( home_url() );
            
            if ( !$co_post ) {
                $co_post = WSKO_Class_Helper::get_random_post();
                if ( $co_post ) {
                    $co_post = $co_post->ID;
                }
            }
            
            ?>
			$('body').itour({
				CSSClass:'anyClassName',				//Assign for tour a unique class name to change the display styles of the tour.
				tourID:'wsko-general-tour',						//This string allows you to save data with a unique name about  tour progress. It can be used to save information on the progress of the tour for several users. Or save the progress of each tour separately
				introShow:true,						//If set to true, before the tour you will see the introductory slide, which will offer to see a tour.
				introCover:false,						//Path to the cover of tour
				startStep:1,							//Step from which the tour begins
				tourMapEnable:true,						//Tour Map Enable
				tourMapPos:'right',						//Tour Map Position 
				tourMapJump:true,						//If set to false, then links of steps on the tour map will not be clickable
				tourTitle:'BAVOKO SEO Tools',			//Tour title
				tourMapVisible:false,					//Specifies to show or hide the map of the tour at the start of the tour
				spacing:10,								//Indent highlighting around the element
				overlayClickable:true,					//This parameter enables or disables the click event for overlying layer
				modalCancelVisible:true,				//Shows a cancel button in modal window.
				stepNumbersVisible:true,				//Shows the total number of steps and the current step number
				showAbsentElement:false,				//Shows an absent element in tour map and find this element in DOM.
				tourContinue:true,						//This parameter add the ability to continue the unfinished tour.
				textDirection:'ltr',					//The direction property specifies the text direction/writing direction. (ltr, rtl)
				lang: {									//Default language settings
					cancelText:	'Cancel Tour',			//The text in the cancel tour button
					hideText: 'Hide Tour Map',			//The text in the hidden tour map button 
					tourMapText:'•••',					//The text in the show tour button
					tourMapTitle: 'Tour Map',			//Title of Tour map button
					nextTextDefault:'Next',				//The text in the Next Button
					prevTextDefault:'Prev',				//The text in the Prev Button
					endText:'End Tour',					//sets the text for the close button in the last step of the tour
					contDialogTitle:'Continue the unfinished tour?',										//Title of continue dialog
					contDialogContent:'Click "Continue" to start with step on which finished last time.',	//Content of continue dialog
					contDialogBtnBegin:'Start from beginning',												//Text in the start button of continue dialog 
					contDialogBtnContinue:'Continue',														//Text in the continue button of continue dialog 
					introTitle:'Welcome!', 											//Title of introduction dialog
					introContent:"After you've completely set up BAVOKO SEO Tools, it can take up to an hour for all the data to be fully available for SEO analysis in the backend. Start the plugin tour now for a little introduction to BAVOKO SEO Tools!",				//Content of introduction dialog
					introDialogBtnStart:'Start',															//Text in the start button of introduction dialog
					introDialogBtnCancel:'Cancel'															//Text in the cancel button of introduction dialog
				},
				steps:[
				{
					title:'SEO Dashboard',
					content:'After the API connections and the Onpage Crawler have completely saved the data, you will find the most important SEO KPIs and history data of all sections in the Dashboard of BAVOKO SEO Tools.',
					contentPosition:'auto',
					name:'wsko_dashboard',
					event:'next',
					nextText:'Next',
					trigger:false
				},
				{
					title:'Ranking Analysis & Keyword Research',
					content:'Inside the "Search" section you can analyze your rankings in detail by pages, keywords, countries & devices (PRO), work with different keyword research tools (PRO) and track your most important search terms within the SEO monitoring tool. ',
					contentPosition:'auto',
					name:'wsko_search',
					event:'next',
					nextText:'Next',
					trigger:false
				},
				{
					title:'Onpage SEO Analysis',
					content:'Within the onpage analysis you can check your pages for the most important SEO aspects such as titles, descriptions, content length, or even indexability (PRO) and optimize them in a unique workflow without having to leave the analysis.',
					contentPosition:'auto',
					name:'wsko_onpage',
					event:'next',
					nextText:'Next',
					trigger:false
				},
				{
					title:'Backlink Analysis',
					content:'Analyze referring domains and pages within the backlink views and use the disavow tool to mark spam links and to submit them to Google with a few clicks. ',
					contentPosition:'auto',
					name:'wsko_backlinks',
					event:'next',
					nextText:'Next',
					trigger:false
				},
				{
					title:'Pagespeed & Requests (PRO)',
					content:'Within the performance section you can not only analyze your pagespeed, but also check the individual CSS, javascript and image requests of your website in detail.',
					contentPosition:'auto',
					name:'wsko_performance',
					event:'next',
					nextText:'Next',
					trigger:false
				},
				{
					image:'',
					title:'SEO Tools',
					content:'Here you will find various SEO tools for metas, redirects, permalinks, sitemaps and much more. We recommend you to carefully review all settings in this section after this tour and take a closer look at the corresponding articles in our knowledge base.',
					contentPosition:'auto',
					name:'wsko_tools',
					event:'next',
					nextText:'<?php 
            echo  ( $co_post ? 'Next' : 'End Tour' ) ;
            ?>',					//The text in the Next Button
					trigger:false,
				},
				{
					image:'',
					title:'SEO Workflow',
					content:'Within the analysis views, you can edit your single pages without leaving the view by clicking on the CO symbol.',
					contentPosition:'auto',
					name:'wsko_tools',
					event:'next',
					stepID:'wsko_tour_pre_co',	
					nextText:'<?php 
            echo  ( $co_post ? '<a href="#" class="wsko-content-optimizer-link wsko-tour-co"><small class="wsko-content-optimizer-link-text">CO</small></a>' : 'End Tour' ) ;
            ?>',					//The text in the Next Button
					prevText:'',
					trigger:false,
				}
				<?php 
            
            if ( $co_post ) {
                ?>
				,{
					title:'Content Optimizer',
					content:'With the Content Optimizer you can analyze and optimize your single pages by using various tools for content optimization, keywords, meta tags, social snippets, page rankings and more. You can reach it within your posts and pages, as well as in the analysis area via this popup.',
					contentPosition:'auto',
					name:'wsko_content_optimizer',
					event:'next',
					nextText:'Next',
					trigger:false,
					before:function(){ jQuery.wsko_open_optimizer_modal(<?php 
                echo  $co_post ;
                ?>, 'post_id', ''); },
					after:function(){$('#wsko_content_optimizer_modal .wsko-modal-close').click(); },
				}
			<?php 
            }
            
            ?>
				,{
					image:'',
					title:'End of Tour',
					content:'The tour is over! Thank you for your kind attention! Until the SEO data is available for analysis, we recommend you to set up your metas, permalinks and sitemap under "Tools" as a next step. Click the following link for more information about BAVOKO SEO Tools: <a href="https://www.bavoko.tools/knowledge_base/bst-wp-seo-plugin-tutorial/" target="_blank">Getting Started in BAVOKO SEO Tools</a>. Good luck with your rankings!',
					contentPosition:'auto',
					name:'wsko_logo',
					event:'next',
					nextText:'End Tour',					//The text in the Next Button
					trigger:false,
				}	

				/*{
					image:'',							//Path to image file
					title:'SEO Tools',				//Name of step
					content:'Here you will find various SEO tools for metas, redirects, permalinks, sitemaps and much more. We recommend you to carefully review all settings in this area after this tour and take a closer look at the corresponding help texts in our knowledge base.',		//Description of step
					contentPosition:'auto',				//Position of message
					name:'wsko_tools',					//Unique Name (<div data-name="uniqueName"></div>) of highlighted element or .className (<div class="className"></div>) or #idValue (<div id="idValue"></div>)
					disable:false,						//Block access to element
					overlayOpacity:0.5,					//For each step, you can specify the different opacity values of the overlay layer.
					event:'next',						//An event that you need to do to go to the next step
					skip: false,						//Step can be skipped if you set parameter "skip" to true.
					nextText:'Next',					//The text in the Next Button
					prevText:'Prev',					//The text in the Prev Button
					trigger:false,						//An event which is generated on the selected element, in the transition from step to step
					stepID:'',							//Unique ID Name. This name is assigned to the "html" tag as "data-step" attribute (If not specified, the plugin generates it automatically in the form: "step-N")
					loc:false,							//The path to the page on which the step should work
					before:function(){},				//Triggered before the start of step
					during:function(){},				//Triggered after the onset of step
					after:function(){},					//Triggered After completion of the step, but before proceeding to the next
					delayBefore:0,						//The delay before the element search, ms
					delayAfter:0						//The delay before the transition to the next step, ms
				}*/],
				create: function(){},					//Triggered when the itour is created
				end: function(){
					jQuery.wsko_post_element({action:'wsko_controller_tour_ended', tour:'global', nonce: '<?php 
            echo  wp_create_nonce( 'wsko_controller_tour_ended' ) ;
            ?>'}, function(res){ return true; }, function(){ return true; }, false, false);
				},						//Triggered when the tour ended, or was interrupted
				abort: function(){},					//Triggered when the tour aborted
				finish: function(){}					//Triggered when step sequence is over
				});<?php 
        }
        
        ?>
		}; <?php 
        
        if ( !WSKO_Class_Core::get_user_setting( 'tour_skipped_global' ) ) {
            //($tour && !$tour['skipped']) {
            ?>
			jQuery.wsko_open_controller_tour();<?php 
        }
        
        if ( $return ) {
            return ob_get_clean();
        }
    }
    
    public function build_js_tour()
    {
        global  $wsko_curr_tour_contents ;
        if ( $wsko_curr_tour_contents ) {
            return $wsko_curr_tour_contents;
        }
        $inst = static::get_instance();
        
        if ( $inst ) {
            $subpage = $inst->get_current_subpage();
            $con = $inst->_build_js_tour( $subpage );
            
            if ( $con ) {
                $con['name'] = $name = get_class( $inst ) . $subpage;
                $con['skipped'] = WSKO_Class_Core::get_user_setting( 'tour_skipped_' . $name );
                return $wsko_curr_tour_contents = $con;
            }
        
        }
        
        return array();
    }
    
    public function _build_js_tour( $subpage )
    {
    }
    
    public function get_subpage_ext_link( $subpage )
    {
        //abstract
        return '';
    }
    
    public function get_help_content( $subpage )
    {
        $inst = static::get_instance();
        
        if ( $inst ) {
            $tags = $inst->get_knowledge_base_tags( $subpage );
            
            if ( $tags ) {
                ob_start();
                ?><p class="wsko-label-sm">Knowledge Base</h2><?php 
                $kb_articles = WSKO_Class_Knowledge::search_knowledge_base(
                    'kb',
                    false,
                    array(),
                    $tags
                );
                
                if ( $kb_articles ) {
                    ?> <ul> <?php 
                    foreach ( $kb_articles as $a ) {
                        ?><li class="panel panel-body"><a href="#" class="wsko-open-knowledge-base-article dark" data-article="<?php 
                        echo  $a->id ;
                        ?>" data-type="kb">
							<p><?php 
                        echo  $a->title ;
                        ?></p>
							<small class="text-off"><?php 
                        echo  $a->preview ;
                        ?></small>
						</a></li><?php 
                    }
                    ?> </ul> <?php 
                } else {
                    ?><ul><li>No Articles found.</li></ul><?php 
                }
                
                ?><p class="wsko-label-sm">Question & Answer</p><?php 
                $qa_articles = WSKO_Class_Knowledge::search_knowledge_base(
                    'q_and_a',
                    false,
                    array(),
                    $tags
                );
                
                if ( $qa_articles ) {
                    ?> <ul> <?php 
                    foreach ( $qa_articles as $a ) {
                        ?><li class="panel panel-body"><a href="#" class="wsko-open-knowledge-base-article dark" data-article="<?php 
                        echo  $a->id ;
                        ?>" data-type="q_and_a">
							<p><?php 
                        echo  $a->title ;
                        ?></p>
							<small class="text-off"><?php 
                        echo  $a->preview ;
                        ?></small>
						</a></li><?php 
                    }
                    ?> </ul> <?php 
                } else {
                    ?><ul><li>No Articles found.</li></ul><?php 
                }
                
                return ob_get_clean();
            }
        
        }
        
        return __( "No help available", "wsko" );
    }
    
    public function get_knowledge_base_tags( $subpage )
    {
        return array();
    }
    
    public function is_accessible( $subpage = false )
    {
        $inst = static::get_instance();
        
        if ( method_exists( $inst, '_is_accessible' ) ) {
            global  $wsko_accessibles ;
            $class = get_class( $inst ) . (( $subpage ? '_' . $subpage : '' ));
            if ( isset( $wsko_accessibles[$class] ) ) {
                return $wsko_accessibles[$class];
            }
            return $wsko_accessibles[$class] = $inst->_is_accessible( $subpage );
        }
        
        return true;
    }
    
    /*Actions*/
    public function action_load_lazy_data()
    {
        $controller = WSKO_Class_Core::get_current_controller();
        
        if ( $controller ) {
            $action = ( isset( $_POST['wsko_action'] ) ? sanitize_text_field( $_POST['wsko_action'] ) : false );
            $lazy_data = ( isset( $_POST['lazy_data'] ) ? $_POST['lazy_data'] : false );
            
            if ( $action && $action != 'page' ) {
                WSKO_Class_Helper::safe_set_time_limit( 60 );
                $func = 'load_lazy_' . $action;
                if ( method_exists( $controller, $func ) ) {
                    return $controller->{$func}( $lazy_data );
                }
            }
        
        }
        
        return false;
    }
    
    public function action_get_attachment_popup()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $attachment = ( isset( $_POST['attachment'] ) ? $_POST['attachment'] : false );
        
        if ( $attachment ) {
            $view = get_media_item( $attachment );
            if ( $view ) {
                return array(
                    'success' => true,
                    'view'    => $view,
                );
            }
        }
    
    }
    
    public function action_load_lazy_page()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $controller = WSKO_Class_Core::get_current_controller();
        
        if ( $controller ) {
            $widget = ( isset( $_POST['widget'] ) && $_POST['widget'] ? true : false );
            global  $wsko_plugin_path ;
            $header = '<div id="wsko_admin_view_timespan_wrapper" class="hidden-xs">';
            if ( $controller->uses_timespan( $controller->get_current_subpage() ) ) {
                $header .= WSKO_Class_Template::render_timespan_widget( true );
            }
            $header .= '</div>' . $controller->get_header_widget( true );
            return array(
                'success'    => true,
                'title'      => $controller->get_title(),
                'tab_title'  => $controller->get_title_s( true, true ),
                'breadcrump' => $controller->get_breadcrump(),
                'notif'      => $controller->notifications( true ),
                'view'       => $controller->view( $widget, true ),
                'scripts'    => $controller->get_scripts( $widget, true ),
                'footer'     => $controller->content_footer( true ),
                'header'     => $header,
            );
        }
    
    }
    
    public function action_get_help_content()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $view = false;
        $controller = WSKO_Class_Core::get_current_controller();
        if ( $controller ) {
            $view = $controller->get_help_content( $controller->get_current_subpage() );
        }
        return array(
            'success' => true,
            'view'    => $view,
        );
    }
    
    public function action_set_timespan()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $controller = WSKO_Class_Core::get_current_controller();
        
        if ( $controller->uses_timespan && isset( $_POST['start_time'] ) && $_POST['start_time'] && isset( $_POST['end_time'] ) && $_POST['end_time'] ) {
            $controller->set_timespan( intval( $_POST['start_time'] ), intval( $_POST['end_time'] ) );
            return true;
        }
    
    }
    
    public function action_reset_timespan()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $controller = WSKO_Class_Core::get_current_controller();
        
        if ( $controller->uses_timespan ) {
            $controller->set_timespan( 0, 0 );
            return true;
        }
    
    }
    
    public function action_save_ajax_input()
    {
        if ( !$this->can_execute_action( defined( 'WSKO_DEMO_SWITCH' ) && WSKO_DEMO_SWITCH ) ) {
            return false;
        }
        
        if ( isset( $_POST['target'] ) && $_POST['target'] ) {
            $target = sanitize_text_field( $_POST['target'] );
            $val = ( isset( $_POST['val'] ) && $_POST['val'] ? sanitize_text_field( $_POST['val'] ) : false );
            $setting = ( isset( $_POST['setting'] ) && $_POST['setting'] ? sanitize_text_field( $_POST['setting'] ) : false );
            switch ( $target ) {
                case 'settings':
                    
                    if ( $setting ) {
                        $set = ( $val && $val !== 'false' ? $val : false );
                        WSKO_Class_Core::save_setting( $setting, $set );
                        switch ( $setting ) {
                            case 'hide_category_slug':
                                if ( isset( $_POST['alert'] ) ) {
                                    
                                    if ( $_POST['alert'] && $_POST['alert'] != 'false' ) {
                                        WSKO_Class_Core::save_setting( 'hide_category_slug_redirect', true );
                                    } else {
                                        WSKO_Class_Core::save_setting( 'hide_category_slug_redirect', false );
                                    }
                                
                                }
                                break;
                        }
                        return true;
                    }
                    
                    break;
                case 'user_settings':
                    
                    if ( $setting ) {
                        $set = ( $val && $val !== 'false' ? $val : false );
                        WSKO_Class_Core::save_user_setting( $setting, $set );
                        /*switch($setting)
                        		{
                        			case 'backlinks_view_filter':
                        				$this->delete_cache();
                        			break;
                        		}*/
                        return true;
                    }
                    
                    break;
                case 'onpage_sitemap_post_exclude':
                    $post = ( $setting ? intval( $setting ) : false );
                    
                    if ( $post ) {
                        $set = ( $val && $val !== 'false' ? true : false );
                        
                        if ( $set ) {
                            $gen_params = WSKO_Class_Onpage::get_sitemap_params();
                            
                            if ( !isset( $gen_params['excluded_posts'] ) || !is_array( $gen_params['excluded_posts'] ) ) {
                                $gen_params['excluded_posts'] = array( $post );
                            } else {
                                if ( !in_array( $post, $gen_params['excluded_posts'] ) ) {
                                    $gen_params['excluded_posts'][] = $post;
                                }
                            }
                            
                            WSKO_Class_Onpage::set_sitemap_params( $gen_params );
                        } else {
                            $gen_params = WSKO_Class_Onpage::get_sitemap_params();
                            
                            if ( isset( $gen_params['excluded_posts'] ) && is_array( $gen_params['excluded_posts'] ) && ($key = array_search( $post, $gen_params['excluded_posts'] )) !== false ) {
                                unset( $gen_params['excluded_posts'][$key] );
                                WSKO_Class_Onpage::set_sitemap_params( $gen_params );
                            }
                        
                        }
                        
                        return true;
                    }
                    
                    break;
                case 'api_search':
                    
                    if ( $setting ) {
                        $set = ( $val == 'false' ? false : $val );
                        $se_data = WSKO_Class_Search::get_search_data();
                        $se_data[$setting] = $set;
                        WSKO_Class_Search::set_search_data( $se_data );
                        return true;
                    }
                    
                    break;
                case 'api_premium':
                case 'api_analytics':
                    break;
            }
        }
    
    }
    
    public function action_resolve_url()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        
        if ( isset( $_POST['urls'] ) && $_POST['urls'] && is_array( $_POST['urls'] ) ) {
            $urls = array_map( 'sanitize_text_field', $_POST['urls'] );
            $url_res = array();
            $failed_urls = array();
            foreach ( $urls as $url ) {
                $res = WSKO_Class_Helper::url_get_title( $url );
                if ( !$res->resolved ) {
                    $failed_urls[] = $url;
                }
                $url_res[$url] = $res;
            }
            $eff_urls = WSKO_Class_Helper::get_effective_urls( $failed_urls );
            foreach ( $eff_urls as $o_url => $url ) {
                $url_res[$o_url] = WSKO_Class_Helper::url_get_title( $url );
            }
            return array(
                'success' => true,
                'urls'    => $url_res,
            );
        }
    
    }
    
    public function action_send_feedback()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $type = ( isset( $_POST['type'] ) ? intval( $_POST['type'] ) : false );
        $msg = ( isset( $_POST['message'] ) ? sanitize_text_field( $_POST['message'] ) : false );
        $title = ( isset( $_POST['title'] ) ? sanitize_text_field( $_POST['title'] ) : false );
        $email = ( isset( $_POST['email'] ) ? sanitize_email( $_POST['email'] ) : false );
        $name = ( isset( $_POST['name'] ) ? sanitize_text_field( $_POST['name'] ) : false );
        $append_reports = ( isset( $_POST['append_reports'] ) && $_POST['append_reports'] && $_POST['append_reports'] != 'false' ? true : false );
        
        if ( $msg && $title ) {
            $res = false;
            $title = 'BST: ' . $title;
            $msg .= '<br/>Von: ' . $name . ' (' . $email . ')';
            $headers = array( 'From: ' . (( $name ? $name : $email )) . ' <' . $email . '>', 'Content-Type: text/html; charset=UTF-8' );
            global  $wsko_mail_error_temp ;
            $wsko_mail_error_temp = false;
            add_action(
                'wp_mail_failed',
                function ( $wp_error ) {
                global  $wsko_mail_error_temp ;
                $wsko_mail_error_temp = $wp_error;
            },
                10,
                1
            );
            if ( $type == 1 ) {
                
                if ( $append_reports ) {
                    $rep = WSKO_Class_Helper::format_reports();
                    $msg .= "<br/><br/>---------------------------Reports---------------------------<br/><br/>" . $rep;
                }
            
            }
            $res = wp_mail(
                WSKO_SUPPORT_MAIL,
                $title,
                $msg,
                $headers
            );
            global  $wsko_mail_error_temp ;
            if ( $wsko_mail_error_temp ) {
                $res = false;
            }
            
            if ( $res ) {
                return true;
            } else {
                return array(
                    'success' => false,
                    'msg'     => 'Mail could not be sent!',
                );
            }
        
        }
    
    }
    
    public function action_skip_nps_feedback()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $temp = ( isset( $_POST['temp'] ) && $_POST['temp'] && $_POST['temp'] !== 'false' ? true : false );
        $wsko_data = WSKO_Class_Core::get_data();
        
        if ( $temp ) {
            $wsko_data['skipped_feedback_today'] = time();
        } else {
            $wsko_data['skipped_feedback'] = time();
        }
        
        WSKO_Class_Core::save_data( $wsko_data );
        return true;
    }
    
    public function action_discard_notice()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $notice = ( isset( $_POST['notice'] ) ? sanitize_text_field( $_POST['notice'] ) : false );
        
        if ( $notice ) {
            $wsko_data = WSKO_Class_Core::get_data();
            if ( !isset( $wsko_data['discard_notice'] ) || !$wsko_data['discard_notice'] ) {
                $wsko_data['discard_notice'] = array();
            }
            $wsko_data['discard_notice'][] = $notice;
            WSKO_Class_Core::save_data( $wsko_data );
        }
        
        return true;
    }
    
    public function action_controller_tour_ended()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $tour = ( isset( $_POST['tour'] ) ? sanitize_text_field( $_POST['tour'] ) : false );
        if ( $tour ) {
            WSKO_Class_Core::save_user_setting( 'tour_skipped_' . $tour, true );
        }
        return true;
    }
    
    public function action_send_nps_feedback()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $msg = ( isset( $_POST['msg'] ) ? sanitize_text_field( $_POST['msg'] ) : false );
        $rating = ( isset( $_POST['rating'] ) ? intval( $_POST['rating'] ) : false );
        
        if ( $rating ) {
            $data = array(
                'action' => 'nps_feedback',
                'msg'    => $msg,
                'rating' => $rating,
            );
            
            if ( !wsko_fs()->is_activation_mode() && !wsko_fs()->is_pending_activation() ) {
                $user = wsko_fs()->get_user();
                if ( $user && is_object( $user ) ) {
                    $data['mail'] = $user->email;
                }
            }
            
            $res = WSKO_Class_Helper::post_to_url( WSKO_FEEDBACK_API, $data, array( "charset=utf-8" ) );
            
            if ( $res === 'true' ) {
                $wsko_data = WSKO_Class_Core::get_data();
                $wsko_data['feedback_sent'] = true;
                WSKO_Class_Core::save_data( $wsko_data );
                return true;
            }
        
        }
    
    }
    
    public function action_get_content_optimizer()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $post_id = ( isset( $_POST['post'] ) ? intval( $_POST['post'] ) : false );
        $widget = ( isset( $_POST['widget'] ) && $_POST['widget'] && $_POST['widget'] != 'false' ? true : false );
        $preview = ( isset( $_POST['preview'] ) && $_POST['preview'] && $_POST['preview'] != 'false' ? true : false );
        $open_tab = ( isset( $_POST['open_tab'] ) ? $_POST['open_tab'] : false );
        $type = ( isset( $_POST['type'] ) ? $_POST['type'] : false );
        if ( $type === 'post_url' && isset( $_POST['post'] ) ) {
            $post_id = WSKO_Class_Helper::url_to_postid( esc_url( $_POST['post'] ) );
        }
        
        if ( $post_id ) {
            $preview_data = false;
            if ( $preview ) {
                $preview_data = array(
                    'post_title'   => ( isset( $_POST['post_title'] ) ? sanitize_post_field( 'post_title', $_POST['post_title'], $post_id ) : '' ),
                    'post_content' => ( isset( $_POST['post_content'] ) ? sanitize_post_field( 'post_content', $_POST['post_content'], $post_id ) : '' ),
                    'post_slug'    => ( isset( $_POST['post_slug'] ) ? sanitize_title_with_dashes( $_POST['post_slug'] ) : '' ),
                );
            }
            $view = WSKO_Controller_Optimizer::render(
                $post_id,
                $widget,
                $preview_data,
                $open_tab
            );
            if ( $view ) {
                return array(
                    'success' => true,
                    'view'    => $view,
                );
            }
        }
    
    }
    
    public function action_import_plugin()
    {
        if ( !$this->can_execute_action() ) {
            return false;
        }
        $plugin = ( isset( $_POST['plugin'] ) ? sanitize_text_field( $_POST['plugin'] ) : false );
        $options = ( isset( $_POST['options'] ) ? $_POST['options'] : false );
        
        if ( $plugin && $options && is_array( $options ) ) {
            $stats = WSKO_Class_Import::import_plugin( $plugin, $options );
            $view = WSKO_Class_Template::render_template( 'template-import-report.php', array(
                'stats' => $stats,
            ), true );
            return array(
                'success'      => true,
                'report_title' => 'Plugin Import Report',
                'report'       => $view,
            );
        }
    
    }
    
    /*/*/
    public function get_table_data( $data, $params = array(), $is_formated = false )
    {
        $order = ( isset( $_POST['order'] ) ? $_POST['order'] : false );
        $offset = ( isset( $_POST['start'] ) ? intval( $_POST['start'] ) : 0 );
        $count = ( isset( $_POST['length'] ) ? intval( $_POST['length'] ) : 10 );
        $custom_filter = ( isset( $_POST['custom_filter'] ) ? $_POST['custom_filter'] : false );
        if ( $offset < 0 ) {
            $offset = 0;
        }
        if ( $count < 1 ) {
            $count = 1;
        }
        
        if ( $order && $order[0] ) {
            
            if ( $order[0]['dir'] == "asc" ) {
                $orderdir = 1;
            } else {
                $orderdir = 0;
            }
            
            $order = $order[0]['column'];
        } else {
            $order = 0;
            $orderdir = 1;
        }
        
        $search = ( isset( $_POST['search']['value'] ) ? $_POST['search']['value'] : false );
        if ( !isset( $params['search'] ) ) {
            $params['search'] = $search;
        }
        return WSKO_Class_Helper::prepare_data_table(
            $data,
            array(
            'offset' => $offset,
            'count'  => $count,
        ),
            $custom_filter,
            array(
            'key' => $order,
            'dir' => $orderdir,
        ),
            $params,
            $is_formated
        );
    }
    
    /*Timespan*/
    public  $uses_timespan = false ;
    public  $uses_fixed_timespan = false ;
    public  $timespan_start = 0 ;
    public  $timespan_end = 0 ;
    public  $is_default_timespan = false ;
    public function set_timespan( $start_time, $end_time )
    {
        if ( $this->uses_fixed_timespan ) {
            return;
        }
        $this->delete_cache();
        $this->timespan_start = intval( $start_time );
        $this->timespan_end = intval( $end_time );
        //Update Cache
        $this->get_cached_var(
            'timespan',
            true,
            array(),
            true
        );
    }
    
    public function uses_timespan()
    {
        return $this->uses_timespan;
    }
    
    /*Cache*/
    private static  $cache = array() ;
    public function build_cache()
    {
        WSKO_Class_Cache::prepare_session_cache();
        //Global Cache
        
        if ( $this->uses_timespan ) {
            $today = WSKO_Class_Helper::get_midnight();
            
            if ( $this->uses_fixed_timespan ) {
                $this->timespan_start = $today - 60 * 60 * 24 * 30;
                $this->timespan_end = time();
                //$today - (60 * 60 * 24 * 3);
                $this->is_default_timespan = true;
            } else {
                $times = $this->get_cached_var( 'timespan', true );
                //, array(), true);
                $this->timespan_start = $times['start'];
                $this->timespan_end = $times['end'];
                $this->is_default_timespan = false;
                if ( $this->timespan_start == $today - 60 * 60 * 24 * 30 && $this->timespan_end == $today - 60 * 60 * 24 * 3 ) {
                    $this->is_default_timespan = true;
                }
            }
        
        }
    
    }
    
    public function get_cached_var(
        $param_key,
        $parent = false,
        $args = array(),
        $recache = false,
        $expire_time = false
    )
    {
        if ( !$expire_time ) {
            $expire_time = WSKO_Class_Helper::get_midnight( time() + 60 * 60 * 24 ) - time();
        }
        
        if ( $param_key && $param_key != 'var' ) {
            $int = static::get_instance();
            
            if ( $int ) {
                $arg_k = "";
                if ( $args ) {
                    foreach ( $args as $k => $v ) {
                        $arg_k .= $k . '_' . $v;
                    }
                }
                $key = (( $parent ? 'global' : get_class( $int ) )) . '_' . $param_key . '_' . $arg_k;
                //if (!$recache && isset(self::$cache[$key]))
                //return self::$cache[$key];
                $val = WSKO_Class_Cache::get_session_cache( $key );
                
                if ( $recache || !$val ) {
                    $func = 'get_cached_' . $param_key;
                    $val = false;
                    if ( method_exists( $int, $func ) ) {
                        $val = $int->{$func}( $args );
                    }
                    if ( $val ) {
                        WSKO_Class_Cache::set_session_cache( $key, $val, $expire_time );
                    }
                }
                
                //if ($val)
                //self::$cache[$key] = $val;
                return $val;
            }
        
        }
        
        return false;
    }
    
    public function get_cached_var_for_time(
        $param_key,
        $args = array(),
        $recache = false,
        $expire_time = false
    )
    {
        if ( !$expire_time ) {
            $expire_time = WSKO_Class_Helper::get_midnight( time() + 60 * 60 * 24 ) - time();
        }
        
        if ( $param_key && $param_key != 'var' ) {
            $int = static::get_instance();
            
            if ( $int && $int->uses_timespan && $int->timespan_start && $int->timespan_end ) {
                $arg_k = "";
                if ( $args ) {
                    foreach ( $args as $k => $v ) {
                        $arg_k .= $k . '_' . $v;
                    }
                }
                $key = get_class( $int ) . '_' . $param_key . '_' . $int->timespan_start . '_' . $int->timespan_end . '_' . $arg_k;
                //if (!$recache && isset(self::$cache[$key]))
                //return self::$cache[$key];
                $val = WSKO_Class_Cache::get_session_cache( $key );
                
                if ( $recache || !$val ) {
                    $func = 'get_cached_' . $param_key;
                    $val = false;
                    if ( method_exists( $int, $func ) ) {
                        $val = $int->{$func}( $args );
                    }
                    if ( $val ) {
                        WSKO_Class_Cache::set_session_cache( $key, $val, $expire_time );
                    }
                }
                
                //if ($val)
                //self::$cache[$key] = $val;
                return $val;
            }
        
        }
        
        return false;
    }
    
    public function delete_cache( $key = false )
    {
        WSKO_Class_Cache::clear_session_cache( $key );
    }
    
    //Global Cache
    public function get_cached_timespan( $args )
    {
        $res = array();
        $today = WSKO_Class_Helper::get_midnight();
        
        if ( $this->timespan_start ) {
            $res['start'] = $this->timespan_start;
        } else {
            $res['start'] = $today - 60 * 60 * 24 * 30;
        }
        
        
        if ( $this->timespan_end ) {
            $res['end'] = $this->timespan_end;
        } else {
            $res['end'] = $today - 60 * 60 * 24 * 3;
        }
        
        return $res;
    }
    
    /*/*/
    /*Static Helpers*/
    public static function add_wp_nav_links( $callback )
    {
        foreach ( static::$controllers as $c ) {
            $c->add_menu_page( $callback );
        }
    }
    
    public static function get_title_s( $with_prefix = false, $short_prefix = false )
    {
        
        if ( $short_prefix ) {
            $prefix = 'BST';
        } else {
            $prefix = 'BAVOKO SEO Tools';
        }
        
        $int = static::get_instance();
        if ( $int ) {
            return (( $with_prefix ? $prefix . ' - ' : "" )) . $int->get_title();
        }
        return ( $with_prefix ? $prefix : "" );
    }
    
    public static function get_link( $subpage = false, $simple = false, $prefix = true )
    {
        $int = static::get_instance();
        
        if ( $int && $int->link ) {
            $subpages = $int->get_subpages();
            if ( $subpage && $subpages && is_array( $subpages ) && isset( $subpages[$subpage] ) ) {
                return ( $simple ? (( $prefix ? 'wsko_' : '' )) . $subpage : admin_url( 'admin.php?page=wsko_' . $int->link . '&subpage=' . $subpage ) );
            }
            return ( $simple ? (( $prefix ? 'wsko_' : '' )) . $int->link : admin_url( 'admin.php?page=wsko_' . $int->link ) );
        }
        
        return ( $simple ? "" : admin_url( 'admin.php' ) );
    }
    
    public static function get_subpages( $real_pages = true )
    {
        $int = static::get_instance();
        
        if ( $int->link ) {
            
            if ( $int->subpages && is_array( $int->subpages ) ) {
                $subpages = $int->subpages;
                foreach ( $subpages as $k => $p ) {
                    if ( isset( $p['is_ext'] ) && !$p['link'] ) {
                        $subpages[$k]['link'] = $int->get_subpage_ext_link( $k );
                    }
                    
                    if ( isset( $p['is_premium'] ) && (!wsko_fs()->can_use_premium_code() || !wsko_fs()->is_premium()) || !$real_pages && !isset( $p['is_ext'] ) || $real_pages && isset( $p['is_ext'] ) ) {
                        unset( $subpages[$k] );
                    } else {
                        $subpages[$k]['title'] = $int->get_subpage_title( $k );
                    }
                
                }
                return $subpages;
            }
            
            return false;
        }
    
    }
    
    public static function call_redirect( $subpage = false )
    {
        wp_redirect( static::get_link( $subpage ) );
        exit;
    }
    
    public static function call_redirect_raw( $url )
    {
        wp_redirect( $url );
        exit;
    }
    
    public static function get_registered_controller( $name, $switched = false )
    {
        $is_configured = WSKO_Class_Core::is_configured();
        foreach ( static::$controllers as $c ) {
            if ( ($is_configured && (( $switched ? $c->show_in_setup : !$c->show_in_setup )) || !$is_configured && (( $switched ? !$c->show_in_setup : $c->show_in_setup ))) && $c::get_link( false, true, false ) === $name ) {
                return $c;
            }
        }
        return null;
    }
    
    public static function get_main_nav_controllers()
    {
        $res = array();
        foreach ( static::$controllers as $c ) {
            if ( $c->has_main_nav_link ) {
                $res[] = $c;
            }
        }
        return $res;
    }
    
    public static function get_lazy_page_widget_beacon( $subpage = false, $showtab = false, $return = false )
    {
        if ( $return ) {
            ob_start();
        }
        $inst = static::get_instance();
        
        if ( $inst ) {
            ?><div class="wsko-dashboard-page-widget" data-controller="<?php 
            echo  $inst->get_link( false, true, true ) ;
            ?>" data-subpage="<?php 
            echo  $subpage ;
            ?>" data-subtab="<?php 
            echo  $showtab ;
            ?>">
			<?php 
            WSKO_Class_Template::render_preloader( array(
                'size' => 'big',
            ) );
            ?>
			</div><?php 
        }
        
        if ( $return ) {
            return ob_get_clean();
        }
    }
    
    /*/*/
    /*Singleton*/
    public static  $instance ;
    public static function get_instance()
    {
        
        if ( !isset( static::$instance ) ) {
            static::$instance = new static();
            static::$instance->build_cache();
        }
        
        return static::$instance;
    }

}