<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}
class WSKO_Controller_Tools extends WSKO_Controller
{
    //Options
    public  $icon = "wrench" ;
    public  $link = "tools" ;
    public  $scripts = array( 'tools' ) ;
    public  $styles = array( 'tools' ) ;
    public  $template_folder = "tools" ;
    public  $ajax_actions = array(
        'table_tools',
        'set_metas',
        'remove_auto_redirect',
        'save_robots',
        'save_htaccess',
        'add_redirect',
        'check_redirect',
        'update_automatic_redirect',
        'remove_redirect',
        'remove_page_redirect',
        'update_sitemap',
        'upload_sitemap',
        'get_link_popup'
    ) ;
    public  $subpages = array(
        'metas'        => array(
        'template' => 'tools/page-metas.php',
    ),
        'metas_social' => array(
        'template' => 'tools/page-metas-social.php',
    ),
        'links'        => array(
        'template' => 'tools/page-links.php',
    ),
        'linking'      => array(
        'template'   => 'tools/page-linking.php',
        'is_premium' => true,
    ),
        'redirects'    => array(
        'template' => 'tools/page-redirects.php',
    ),
        'sitemap'      => array(
        'template' => 'tools/page-sitemap.php',
    ),
        'robots'       => array(
        'template' => 'tools/page-robots.php',
    ),
    ) ;
    public function get_title()
    {
        return __( 'Tools', 'wsko' );
    }
    
    public function get_subpage_title( $subpage )
    {
        switch ( $subpage ) {
            case 'metas':
                return __( 'Metas', 'wsko' );
            case 'metas_social':
                return __( 'Social Snippets', 'wsko' );
            case 'links':
                return __( 'Permalinks', 'wsko' );
            case 'linking':
                return __( 'Internal Links', 'wsko' );
            case 'redirects':
                return __( 'Redirect Manager', 'wsko' );
            case 'sitemap':
                return __( 'Sitemap', 'wsko' );
            case 'robots':
                return __( '.htaccess & robots.txt', 'wsko' );
        }
        return '';
    }
    
    public function get_knowledge_base_tags( $subpage )
    {
        $res = array( 'tools' );
        switch ( $subpage ) {
            case 'metas':
                $res[] = "tools_metas";
            case 'metas_social':
                $res[] = "tools_social_snippets";
            case 'links':
                $res[] = "tools_permalinks";
            case 'linking':
                $res[] = "tools_internal_links";
            case 'redirects':
                $res[] = "tools_redirect_manager";
            case 'sitemap':
                $res[] = "tools_sitemap";
            case 'robots':
                $res[] = "tools_htaccess";
        }
        return $res;
    }
    
    public function load_lazy_page_data( $lazy_data )
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $notif = "";
        $data = array();
        $page = $this->get_current_subpage();
        
        if ( $page ) {
            $accessible = WSKO_Class_Onpage::seo_plugins_disabled();
            switch ( $page ) {
                case 'metas':
                    
                    if ( $accessible ) {
                        $post_types = WSKO_Class_Helper::get_public_post_types( 'objects' );
                        $taxonomies = get_taxonomies( array(
                            'public' => true,
                        ), 'objects' );
                        foreach ( $post_types as $type ) {
                            $data['post_type_' . $type->name] = WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                                'post_type' => $type->name,
                                'type'      => 'post_type',
                                'meta_view' => 'metas',
                            ), true );
                        }
                        foreach ( $taxonomies as $tax ) {
                            $data['post_tax_' . $tax->name] = WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                                'post_tax'  => $tax->name,
                                'type'      => 'post_tax',
                                'meta_view' => 'metas',
                            ), true );
                        }
                        //$data['other_home'] = WSKO_Class_Template::render_template('template-metas-view.php', array('arg' => 'home', 'type' => 'other', 'meta_view' => 'metas'), true);
                        //$data['other_blog'] = WSKO_Class_Template::render_template('template-metas-view.php', array('arg' => 'blog', 'type' => 'other', 'meta_view' => 'metas'), true);
                    }
                    
                    break;
                case 'metas_social':
                    
                    if ( $accessible ) {
                        $post_types = WSKO_Class_Helper::get_public_post_types( 'objects' );
                        $taxonomies = get_taxonomies( array(
                            'public' => true,
                        ), 'objects' );
                        foreach ( $post_types as $type ) {
                            ob_start();
                            /* ?><ul class="nav nav-tabs nav-justified"><li class="active"><a href="#wsko_metas_post_type_<?=$type->name?>_single" data-toggle="tab">Single Page</a></li><li><a href="#wsko_metas_post_type_<?=$type->name?>_archive" data-toggle="tab">Archive</a></li></ul> 
                            			<div class="tab-content"><div id="wsko_metas_post_type_<?=$type->name?>_single" class="tab-pane fade in active">*/
                            WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                                'post_type' => $type->name,
                                'type'      => 'post_type',
                                'meta_view' => 'social',
                            ) );
                            /* ?></div><div id="wsko_metas_post_type_<?=$type->name?>_archive" class="tab-pane fade"><?php
                            				WSKO_Class_Template::render_template('template-metas-view.php', array('post_type' => $type->name, 'type' => 'post_archive', 'meta_view' => 'social'));
                            			?></div></div><?php */
                            $data['post_type_' . $type->name] = ob_get_clean();
                        }
                        foreach ( $taxonomies as $tax ) {
                            $data['post_tax_' . $tax->name] = WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                                'post_tax'  => $tax->name,
                                'type'      => 'post_tax',
                                'meta_view' => 'social',
                            ), true );
                        }
                        //$data['other_home'] = WSKO_Class_Template::render_template('template-metas-view.php', array('arg' => 'home', 'type' => 'other', 'meta_view' => 'social'), true);
                        //$data['other_blog'] = WSKO_Class_Template::render_template('template-metas-view.php', array('arg' => 'blog', 'type' => 'other', 'meta_view' => 'social'), true);
                    }
                    
                    break;
                case 'links':
                    
                    if ( $accessible ) {
                        $post_types = WSKO_Class_Helper::get_public_post_types( 'objects' );
                        unset( $post_types['post'] );
                        unset( $post_types['page'] );
                        $taxonomies = get_taxonomies( array(
                            'public' => true,
                        ), 'objects' );
                        foreach ( $post_types as $type ) {
                            $data['post_type_' . $type->name] = WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                                'post_type' => $type->name,
                                'type'      => 'post_type',
                                'meta_view' => 'links',
                            ), true );
                        }
                        foreach ( $taxonomies as $tax ) {
                            $data['post_tax_' . $tax->name] = WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                                'post_tax'  => $tax->name,
                                'type'      => 'post_tax',
                                'meta_view' => 'links',
                            ), true );
                        }
                    }
                    
                    break;
                case 'redirects':
                    $redirects = WSKO_Class_Onpage::get_redirects();
                    $page_redirects = WSKO_Class_Onpage::get_page_redirects();
                    $auto_post_redirects = WSKO_Class_Onpage::get_auto_redirects( 'post_id' );
                    $auto_post_type_redirects = WSKO_Class_Onpage::get_auto_redirects( 'post_type' );
                    $table_redirects = array();
                    $table_page_redirects = array();
                    $table_auto_page_redirects = array();
                    $table_auto_pt_redirects = array();
                    $is_admin = current_user_can( 'manage_options' );
                    if ( $redirects ) {
                        foreach ( $redirects as $k => $r ) {
                            $table_redirects[] = array(
                                array(
                                'value' => $r['comp'],
                            ),
                                array(
                                'value' => $r['page'],
                            ),
                                array(
                                'value' => ( $r['type'] == 2 ? 302 : 301 ),
                            ),
                                array(
                                'value' => $r['comp_to'],
                            ),
                                array(
                                'value' => $r['target'] . '<br/><p class="font-unimportant">' . WSKO_Class_Helper::format_url( $r['target'] ) . '</p>',
                            ),
                                array(
                                'value' => ( $is_admin ? WSKO_Class_Template::render_ajax_button(
                                '<i class="fa fa-times"></i>',
                                'remove_redirect',
                                array(
                                'redirects' => $k,
                            ),
                                array(),
                                true
                            ) : '' ),
                            )
                            );
                        }
                    }
                    if ( $page_redirects ) {
                        foreach ( $page_redirects as $k => $r ) {
                            $table_page_redirects[] = array(
                                array(
                                'value' => WSKO_Class_Template::render_url_post_field( $r['post'], array(), true ),
                            ),
                                array(
                                'value' => ( $r['type'] == 2 ? 302 : 301 ),
                            ),
                                array(
                                'value' => $r['to'] . '<br/><p class="font-unimportant">' . WSKO_Class_helper::home_url( $r['to'] ) . '</p>',
                            ),
                                array(
                                'value' => ( $is_admin ? WSKO_Class_Template::render_ajax_button(
                                '<i class="fa fa-times"></i>',
                                'remove_page_redirect',
                                array(
                                'post' => $r['post'],
                            ),
                                array(),
                                true
                            ) : '' ),
                            )
                            );
                        }
                    }
                    if ( $auto_post_redirects ) {
                        foreach ( $auto_post_redirects as $p => $links ) {
                            $table_auto_page_redirects[] = array( array(
                                'value' => WSKO_Class_Template::render_url_post_field( $p, array(), true ),
                            ), array(
                                'order' => count( $links ),
                                'value' => count( $links ) . ' redirect(s) from<br/><ul><li><i>' . implode( '</i></li><li><i>', $links ) . '</li></ul>',
                            ), array(
                                'value' => ( $is_admin ? WSKO_Class_Template::render_ajax_button(
                                '<i class="fa fa-times"></i>',
                                'remove_auto_redirect',
                                array(
                                'type' => 'post_id',
                                'arg'  => $p,
                            ),
                                array(),
                                true
                            ) : '' ),
                            ) );
                        }
                    }
                    if ( $auto_post_type_redirects ) {
                        foreach ( $auto_post_type_redirects as $pt => $redirects ) {
                            $red_temp = "";
                            $sources = $redirects['source'];
                            if ( $sources ) {
                                foreach ( $sources as $slug => $link_snapshot ) {
                                    $red_temp .= 'From: ' . $slug . ' (' . count( $link_snapshot ) . ')' . (( $is_admin ? WSKO_Class_Template::render_ajax_button(
                                        '<i class="fa fa-times"></i>',
                                        'remove_auto_redirect',
                                        array(
                                        'type' => 'post_type',
                                        'arg'  => $pt,
                                        'key'  => $slug,
                                    ),
                                        array(
                                        'no_button' => true,
                                    ),
                                        true
                                    ) : '' )) . '<br/>';
                                }
                            }
                            if ( $red_temp ) {
                                $table_auto_pt_redirects[] = array( array(
                                    'value' => $pt,
                                ), array(
                                    'value' => $red_temp,
                                ), array(
                                    'value' => ( $is_admin ? WSKO_Class_Template::render_ajax_button(
                                    '<i class="fa fa-times"></i>',
                                    'remove_auto_redirect',
                                    array(
                                    'type' => 'post_type',
                                    'arg'  => $pt,
                                ),
                                    array(),
                                    true
                                ) : '' ),
                                ) );
                            }
                        }
                    }
                    $data['redirects'] = WSKO_Class_Template::render_template( 'onpage/view-redirects.php', array(
                        'redirects'                => $table_redirects,
                        'page_redirects'           => $table_page_redirects,
                        'auto_post_type_redirects' => $table_auto_pt_redirects,
                        'atuo_post_redirects'      => $table_auto_page_redirects,
                    ), true );
                    break;
                case 'linking':
                    break;
            }
            return array(
                'success' => true,
                'data'    => $data,
                'notif'   => $notif,
            );
        }
    
    }
    
    public function action_table_tools()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $data = array();
        $is_custom = false;
        $is_formated = false;
        $arg = ( isset( $_POST['arg'] ) ? sanitize_text_field( $_POST['arg'] ) : false );
        $order = ( isset( $_POST['order'] ) ? $_POST['order'] : false );
        $offset = ( isset( $_POST['start'] ) ? intval( $_POST['start'] ) : 0 );
        $count = ( isset( $_POST['length'] ) ? intval( $_POST['length'] ) : 10 );
        $custom_filter = ( isset( $_POST['custom_filter'] ) ? $_POST['custom_filter'] : false );
        $search = ( isset( $_POST['search']['value'] ) ? $_POST['search']['value'] : false );
        if ( $offset < 0 ) {
            $offset = 0;
        }
        if ( $count < 1 ) {
            $count = 1;
        }
        
        if ( $order && $order[0] ) {
            
            if ( $order[0]['dir'] == "asc" ) {
                $orderdir = 1;
            } else {
                $orderdir = 0;
            }
            
            $order = $order[0]['column'];
        } else {
            $order = 0;
            $orderdir = 1;
        }
        
        $filtered_data = 0;
        $total_data = 0;
        $search = ( isset( $_POST['search']['value'] ) ? $_POST['search']['value'] : false );
        switch ( $arg ) {
            case 'bulk_metas':
                $is_custom = true;
                $post_type = 'any';
                if ( $custom_filter ) {
                    foreach ( $custom_filter as $cf ) {
                        if ( $cf['key'] == 'post_type' ) {
                            $post_type = $cf['val'];
                        }
                    }
                }
                $orderby = "";
                $keys = array( 'post_title', 'post_title' );
                if ( isset( $keys[$order] ) ) {
                    $orderby = ( is_array( $keys[$order] ) ? $keys[$order][0] : $keys[$order] );
                }
                $orderdir = ( $orderdir ? 'ASC' : 'DESC' );
                $query = new WP_Query( array(
                    's'              => $search,
                    'post_type'      => $post_type,
                    'posts_per_page' => $count,
                    'offset'         => $offset,
                    'fields'         => 'ids',
                    'orderby'        => $orderby,
                    'order'          => $orderdir,
                ) );
                $res = array();
                foreach ( $query->posts as $p ) {
                    $url = get_permalink( $p );
                    $t = get_the_title( $p );
                    $res[] = array(
                        WSKO_Class_Template::render_url_post_field( $p, array(
                            'open_tab' => 'metas',
                        ), true ),
                        //'<div class="wsko_nowrap" title="'.$url.'"><p style="float:right">'.WSKO_Class_Template::render_content_optimizer_link($p, array(), true).'</p><span><p>'.($t?$t:WSKO_Class_Helper::get_empty_page_title()).'</p><a class="font-unimportant" href="'.$url.'">'.$url.'</a></span></div>',
                        WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                            'post_id'   => $p,
                            'type'      => 'post_id',
                            'meta_view' => 'metas',
                            'collapse'  => true,
                        ), true ),
                    );
                }
                $data = array(
                    'data'     => $res,
                    'filtered' => $query->found_posts,
                    'total'    => $query->found_posts,
                );
                break;
            case 'bulk_social':
                $is_custom = true;
                $post_type = 'any';
                if ( $custom_filter ) {
                    foreach ( $custom_filter as $cf ) {
                        if ( $cf['key'] == 'post_type' ) {
                            $post_type = $cf['val'];
                        }
                    }
                }
                $orderby = "";
                $keys = array( 'post_title', 'post_title' );
                if ( isset( $keys[$order] ) ) {
                    $orderby = ( is_array( $keys[$order] ) ? $keys[$order][0] : $keys[$order] );
                }
                $orderdir = ( $orderdir ? 'ASC' : 'DESC' );
                $query = new WP_Query( array(
                    's'              => $search,
                    'post_type'      => $post_type,
                    'posts_per_page' => $count,
                    'offset'         => $offset,
                    'fields'         => 'ids',
                    'orderby'        => $orderby,
                    'order'          => $orderdir,
                ) );
                $res = array();
                foreach ( $query->posts as $p ) {
                    $url = get_permalink( $p );
                    $t = get_the_title( $p );
                    $res[] = array(
                        WSKO_Class_Template::render_url_post_field( $p, array(
                            'open_tab' => 'metas',
                        ), true ),
                        //'<div class="wsko_nowrap" title="'.$url.'"><p style="float:right">'.WSKO_Class_Template::render_content_optimizer_link($p, array('open_tab' => 'social'), true).'</p><span><p>'.($t?$t:WSKO_Class_Helper::get_empty_page_title()).'</p><a class="font-unimportant" href="'.$url.'">'.$url.'</a></span></div>',
                        WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                            'post_id'   => $p,
                            'type'      => 'post_id',
                            'meta_view' => 'social',
                            'collapse'  => true,
                        ), true ),
                    );
                }
                $data = array(
                    'data'     => $res,
                    'filtered' => $query->found_posts,
                    'total'    => $query->found_posts,
                );
                break;
            case 'bulk_links':
                $is_custom = true;
                $post_type = 'any';
                if ( $custom_filter ) {
                    foreach ( $custom_filter as $cf ) {
                        if ( $cf['key'] == 'post_type' ) {
                            $post_type = $cf['val'];
                        }
                    }
                }
                $orderby = "";
                $keys = array( 'post_title', 'post_title' );
                if ( isset( $keys[$order] ) ) {
                    $orderby = ( is_array( $keys[$order] ) ? $keys[$order][0] : $keys[$order] );
                }
                $orderdir = ( $orderdir ? 'ASC' : 'DESC' );
                $query = new WP_Query( array(
                    's'              => $search,
                    'post_type'      => $post_type,
                    'posts_per_page' => $count,
                    'offset'         => $offset,
                    'fields'         => 'ids',
                    'orderby'        => $orderby,
                    'order'          => $orderdir,
                ) );
                $res = array();
                foreach ( $query->posts as $p ) {
                    $url = get_permalink( $p );
                    $t = get_the_title( $p );
                    $res[] = array(
                        WSKO_Class_Template::render_url_post_field( $p, array(), true ),
                        //'<div class="wsko_nowrap" title="'.$url.'"><p style="float:right">'.WSKO_Class_Template::render_content_optimizer_link($p, array(), true).'</p><span><p>'.($t?$t:WSKO_Class_Helper::get_empty_page_title()).'</p><a class="font-unimportant" href="'.$url.'">'.$url.'</a></span></div>',
                        WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                            'post_id'   => $p,
                            'type'      => 'post_id',
                            'meta_view' => 'links',
                            'collapse'  => true,
                        ), true ),
                    );
                }
                $data = array(
                    'data'     => $res,
                    'filtered' => $query->found_posts,
                    'total'    => $query->found_posts,
                );
                break;
            case 'linking_pages':
                break;
            case 'linking_orphaned':
                break;
            case 'sitemap':
                $data = array();
                $sitemap_real_path = get_home_path() . 'sitemap_bst.xml';
                
                if ( file_exists( $sitemap_real_path ) ) {
                    $xml = simplexml_load_file( $sitemap_real_path );
                    
                    if ( $xml ) {
                        $childs = $xml->children();
                        foreach ( $childs as $child ) {
                            $data[] = array(
                                'page'          => $child->loc->__toString(),
                                'last_modified' => strtotime( $child->lastmod->__toString() ),
                                'freq'          => ( $child->changefreq ? $child->changefreq->__toString() : '' ),
                                'prio'          => ( $child->priority ? $child->priority->__toString() : '0.5 (default)' ),
                            );
                        }
                    }
                
                }
                
                $params = array(
                    'format' => array(
                    '0' => 'url',
                ),
                );
                break;
        }
        
        if ( $data ) {
            if ( !$is_custom ) {
                $data = $this->get_table_data( $data, $params, $is_formated );
            }
            if ( !$filtered_data && isset( $data['filtered'] ) ) {
                $filtered_data = $data['filtered'];
            }
            if ( !$total_data && isset( $data['total'] ) ) {
                $total_data = $data['total'];
            }
        }
        
        return array(
            'success'         => true,
            'data'            => ( $data ? $data['data'] : array() ),
            'recordsFiltered' => $filtered_data,
            'recordsTotal'    => $total_data,
        );
    }
    
    public function action_set_metas()
    {
        if ( !$this->can_execute_action( defined( 'WSKO_DEMO_SWITCH' ) && WSKO_DEMO_SWITCH ) ) {
            return false;
        }
        $data = false;
        $data_str = ( isset( $_POST['data'] ) ? $_POST['data'] : false );
        if ( $data_str ) {
            parse_str( $data_str, $data );
        }
        
        if ( isset( $data['robots_ni'] ) || isset( $data['robots_nf'] ) ) {
            $robots_ni = ( isset( $data['robots_ni'] ) && $data['robots_ni'] && $data['robots_ni'] != 'false' ? true : false );
            $robots_nf = ( isset( $data['robots_nf'] ) && $data['robots_nf'] && $data['robots_nf'] != 'false' ? true : false );
            unset( $data['robots_ni'] );
            unset( $data['robots_nf'] );
            $data['robots'] = ( $robots_ni ? ( $robots_nf ? 3 : 2 ) : (( $robots_nf ? 1 : 0 )) );
        }
        
        $canon_data = false;
        
        if ( isset( $data['canon_t'] ) ) {
            $canon_d = $data['canon'];
            $canon_data = array(
                'type' => ( is_numeric( $canon_d ) ? 2 : 3 ),
                'arg'  => ( is_numeric( $canon_d ) ? intval( $canon_d ) : $canon_d ),
            );
            
            if ( $data['canon_t'] === '0' ) {
                $canon_data['type'] = 0;
            } else {
                if ( $data['canon_t'] === '1' ) {
                    $canon_data['type'] = 1;
                }
            }
        
        }
        
        if ( isset( $data['canon_t'] ) ) {
            unset( $data['canon_t'] );
        }
        if ( isset( $data['hide_slug'] ) ) {
            unset( $data['hide_slug'] );
        }
        //temporary disabled
        if ( isset( $data['hide_slug'] ) ) {
            $data['hide_slug'] = ( $data['hide_slug'] && $data['hide_slug'] != 'false' ? true : false );
        }
        $meta_view = ( isset( $data['meta_view'] ) ? sanitize_text_field( $data['meta_view'] ) : false );
        $collapse = ( isset( $data['collapse'] ) && $data['collapse'] && $data['collapse'] != 'false' ? true : false );
        $type = ( isset( $_POST['type'] ) ? sanitize_text_field( $_POST['type'] ) : false );
        $arg = ( isset( $_POST['arg'] ) ? sanitize_text_field( $_POST['arg'] ) : false );
        
        if ( $type && $arg ) {
            $data = array_map( 'stripslashes', array_map( 'sanitize_text_field', $data ) );
            $data_pre = WSKO_Class_Onpage::get_meta_object( $arg, $type );
            if ( $canon_data ) {
                $data['canon'] = $canon_data;
            }
            
            if ( isset( $data['url'] ) ) {
                
                if ( $type === "post_id" ) {
                    $post = intval( $arg );
                    $url = sanitize_title_with_dashes( WSKO_Class_Helper::map_special_chars( $data['url'] ) );
                    if ( $post && $url ) {
                        wp_update_post( array(
                            'ID'        => $post,
                            'post_name' => $url,
                        ) );
                    }
                } else {
                    if ( $type === "post_type" || $type === "post_tax" ) {
                        $data['slug'] = trim( $data['url'], ' ' );
                    }
                }
                
                unset( $data['url'] );
            }
            
            if ( $type !== "post_type" ) {
                unset( $data['hide_slug'] );
            }
            WSKO_Class_Onpage::update_automatic_redirects(
                $type,
                $arg,
                ( isset( $data['hide_slug'] ) && $data['hide_slug'] ? '/' : (( isset( $data['slug'] ) && $data['slug'] ? $data['slug'] : false )) ),
                ( isset( $data['create_redirects'] ) && $data['create_redirects'] && $data['create_redirects'] !== 'false' ? true : false )
            );
            if ( isset( $data['create_redirects'] ) ) {
                unset( $data['create_redirects'] );
            }
            if ( $data_pre ) {
                $data = $data + $data_pre;
            }
            //array_merge($data_pre, $data);
            if ( isset( $data['meta_view'] ) ) {
                unset( $data['meta_view'] );
            }
            if ( isset( $data['collapse'] ) ) {
                unset( $data['collapse'] );
            }
            
            if ( isset( $_POST['reset'] ) && $_POST['reset'] ) {
                WSKO_Class_Onpage::unset_meta_object( $arg, $type );
            } else {
                WSKO_Class_Onpage::set_meta_object( $arg, $data, $type );
            }
            
            $type_s = ( $type === 'post_archive' ? 'post_type' : (( $type === 'other' ? 'arg' : $type )) );
            WSKO_Class_Helper::refresh_permalinks();
            $view = WSKO_Class_Template::render_template( 'template-metas-view.php', array(
                $type_s            => $arg,
                'type'             => $type,
                'meta_view'        => $meta_view,
                'collapse'         => $collapse,
                'is_collapse_open' => true,
            ), true );
        }
        
        if ( $view ) {
            return array(
                'success'  => true,
                'new_view' => $view,
            );
        }
    }
    
    public function action_remove_auto_redirect()
    {
        if ( !$this->can_execute_action( defined( 'WSKO_DEMO_SWITCH' ) && WSKO_DEMO_SWITCH ) ) {
            return false;
        }
        $type = ( isset( $_POST['type'] ) ? sanitize_text_field( $_POST['type'] ) : false );
        $arg = ( isset( $_POST['arg'] ) ? sanitize_text_field( $_POST['arg'] ) : false );
        $key = ( isset( $_POST['key'] ) ? sanitize_text_field( $_POST['key'] ) : false );
        if ( $type && $arg ) {
            WSKO_Class_Onpage::remove_auto_redirect( $type, $arg, $key );
        }
        return true;
    }
    
    public function action_save_robots()
    {
        if ( !$this->can_execute_action() ) {
            return false;
        }
        
        if ( WSKO_Class_Core::get_setting( 'activate_editor_robots' ) ) {
            $robots_path = get_home_path() . 'robots.txt';
            $robots_exists = file_exists( $robots_path );
            
            if ( $robots_exists && is_writable( $robots_path ) || !$robots_exists && is_writable( get_home_path() ) ) {
                global  $wsko_plugin_path ;
                $robots = ( isset( $_POST['robots'] ) ? "" . $_POST['robots'] : "" );
                if ( $robots_exists ) {
                    WSKO_Class_Helper::backup_file( $robots_path );
                }
                file_put_contents( $robots_path, $robots );
                return true;
            }
        
        }
    
    }
    
    public function action_save_htaccess()
    {
        if ( !$this->can_execute_action() ) {
            return false;
        }
        
        if ( WSKO_Class_Core::get_setting( 'activate_editor_htaccess' ) ) {
            $htaccess_path = get_home_path() . '.htaccess';
            $htaccess_exists = file_exists( $htaccess_path );
            
            if ( $htaccess_exists && is_writable( $htaccess_path ) || !$htaccess_exists && is_writable( get_home_path() ) ) {
                global  $wsko_plugin_path ;
                $htaccess = ( isset( $_POST['htaccess'] ) ? "" . $_POST['htaccess'] : "" );
                if ( $htaccess_exists ) {
                    WSKO_Class_Helper::backup_file( $htaccess_path );
                }
                file_put_contents( $htaccess_path, $htaccess );
                return true;
            }
        
        }
    
    }
    
    public function action_add_redirect()
    {
        if ( !$this->can_execute_action( defined( 'WSKO_DEMO_SWITCH' ) && WSKO_DEMO_SWITCH ) ) {
            return false;
        }
        $comp = ( isset( $_POST['comp'] ) ? sanitize_text_field( $_POST['comp'] ) : false );
        $comp_to = ( isset( $_POST['comp_to'] ) ? sanitize_text_field( $_POST['comp_to'] ) : false );
        $type = ( isset( $_POST['type'] ) ? intval( $_POST['type'] ) : false );
        $redirect_to = ( isset( $_POST['redirect_to'] ) ? sanitize_text_field( $_POST['redirect_to'] ) : false );
        $page = ( isset( $_POST['page'] ) ? sanitize_text_field( $_POST['page'] ) : false );
        
        if ( $page && $redirect_to && $comp && $comp_to && $type ) {
            WSKO_Class_Onpage::add_redirect(
                $page,
                $comp,
                $redirect_to,
                $comp_to,
                $type
            );
            return true;
        }
    
    }
    
    public function action_check_redirect()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $url = ( isset( $_POST['url'] ) ? esc_url( $_POST['url'] ) : false );
        $status_check = ( isset( $_POST['status_check'] ) && $_POST['status_check'] && $_POST['status_check'] !== 'false' ? true : false );
        $view = false;
        if ( $url ) {
            $view = WSKO_Class_Template::render_template( 'onpage/view-url-check.php', array(
                'url'          => $url,
                'status_check' => $status_check,
            ), true );
        }
        if ( $view ) {
            return array(
                'success' => true,
                'view'    => $view,
            );
        }
    }
    
    public function action_remove_redirect()
    {
        if ( !$this->can_execute_action( defined( 'WSKO_DEMO_SWITCH' ) && WSKO_DEMO_SWITCH ) ) {
            return false;
        }
        $redirects = ( isset( $_POST['redirects'] ) ? $_POST['redirects'] : false );
        if ( ($redirects || $redirects == '0') && !is_array( $redirects ) ) {
            $redirects = array( $redirects );
        }
        
        if ( $redirects ) {
            WSKO_Class_Onpage::remove_redirects( $redirects );
            return array(
                'success'   => true,
                'redirects' => $redirects,
            );
        }
    
    }
    
    public function action_remove_page_redirect()
    {
        if ( !$this->can_execute_action( defined( 'WSKO_DEMO_SWITCH' ) && WSKO_DEMO_SWITCH ) ) {
            return false;
        }
        $post = ( isset( $_POST['post'] ) ? intval( $_POST['post'] ) : false );
        
        if ( $post ) {
            $data = WSKO_Class_Onpage::get_technical_seo_data( $post );
            unset( $data['redirect'] );
            WSKO_Class_Onpage::set_technical_seo_data( $post, $data );
            return true;
        }
    
    }
    
    public function action_update_automatic_redirect()
    {
        if ( !$this->can_execute_action( defined( 'WSKO_DEMO_SWITCH' ) && WSKO_DEMO_SWITCH ) ) {
            return false;
        }
        $activate = ( isset( $_POST['activate'] ) && $_POST['activate'] && $_POST['activate'] != 'false' ? true : false );
        $type = ( isset( $_POST['type'] ) ? intval( $_POST['type'] ) : "" );
        $custom = ( isset( $_POST['custom'] ) ? sanitize_text_field( $_POST['custom'] ) : "" );
        
        if ( $type ) {
            WSKO_Class_Onpage::set_redirect_404( $activate, $type, $custom );
            return true;
        }
    
    }
    
    public function action_change_sitemap()
    {
        if ( !$this->can_execute_action() ) {
            return false;
        }
        $res = WSKO_Class_Onpage::generate_sitemap();
        if ( $res ) {
            return true;
        }
    }
    
    public function action_update_sitemap()
    {
        if ( !$this->can_execute_action() ) {
            return false;
        }
        $onpage_data = WSKO_Class_Onpage::get_onpage_data();
        $types = array();
        if ( isset( $_POST['types'] ) && is_array( $_POST['types'] ) && $_POST['types'] ) {
            foreach ( $_POST['types'] as $type ) {
                $types[sanitize_text_field( $type['name'] )] = array(
                    'freq' => sanitize_text_field( $type['freq'] ),
                    'prio' => floatval( str_replace( ',', '.', $type['prio'] ) ),
                );
            }
        }
        $stati = array();
        if ( isset( $_POST['stati'] ) && is_array( $_POST['stati'] ) && $_POST['stati'] ) {
            $stati = array_map( 'sanitize_text_field', $_POST['stati'] );
        }
        $gen_params = WSKO_Class_Onpage::get_sitemap_params();
        $gen_params['types'] = $types;
        $gen_params['stati'] = $stati;
        WSKO_Class_Onpage::set_sitemap_params( $gen_params );
        
        if ( isset( $_POST['ping'] ) && $_POST['ping'] && $_POST['ping'] != 'false' ) {
            WSKO_Class_Core::save_setting( 'automatic_sitemap_ping', true );
        } else {
            WSKO_Class_Core::save_setting( 'automatic_sitemap_ping', false );
        }
        
        
        if ( isset( $_POST['auto_generation'] ) && $_POST['auto_generation'] && $_POST['auto_generation'] != 'false' ) {
            WSKO_Class_Core::save_setting( 'automatic_sitemap', true );
            WSKO_Class_Crons::bind_sitemap_generation();
        } else {
            WSKO_Class_Core::save_setting( 'automatic_sitemap', false );
            WSKO_Class_Crons::unbind_sitemap_generation();
        }
        
        $res = WSKO_Class_Onpage::generate_sitemap();
        if ( $res ) {
            return true;
        }
    }
    
    public function action_upload_sitemap()
    {
        if ( !$this->can_execute_action() ) {
            return false;
        }
        $res = WSKO_Class_Onpage::upload_sitemap();
        if ( $res ) {
            return true;
        }
    }
    
    public function action_get_link_popup()
    {
        if ( !$this->can_execute_action( false ) ) {
            return false;
        }
        $url = ( isset( $_POST['url'] ) ? esc_url( $_POST['url'] ) : false );
        $ext = ( isset( $_POST['ext'] ) && $_POST['ext'] ? true : false );
        $rec = ( isset( $_POST['rec'] ) && $_POST['rec'] ? true : false );
    }
    
    public function _is_accessible( $subpage = false )
    {
        if ( $subpage == "metas" || $subpage == "metas_social" || $subpage == "links" || $subpage == "sitemap" ) {
            return WSKO_Class_Onpage::seo_plugins_disabled();
        }
        return true;
    }
    
    //Singleton
    static  $instance ;
}
WSKO_Controller_Tools::init_controller();