jQuery(document).ready(function($) {
    $('.nps-form:not(.wsko-init)').addClass('wsko-init').each(function(index){
        var $form = $(this),
        $container = $form.closest('.nps-wrapper');
        $form.submit(function(event){
            event.preventDefault();
            jQuery.wsko_post_element({action: 'wsko_send_nps_feedback', rating: $form.find('.nps-rating:checked').val(), msg: $form.find('.nps-msg').val(), nonce: $form.data('nonce')}, function(res){
                if (res.success)
                {
                    $container.find('.nps-second-step').show();           
                    $container.find('.nps-first-step').hide();    
                }
            }, function(){}, $container, false);
        }); 
        if ($container.hasClass('active'))  
            $container.delay('5000').addClass('in');
    
        $container.find('.nps-close').click(function(event){
            event.preventDefault();        
            $container.removeClass('active').fadeOut( 1000 );
        });
    
        $container.find('.nps-rating-wrapper input').change(function() {
            $container.find('.nps-inner-form').show();
        });
        /*$container.find('.nps-submit').click(function(event) {
            //event.stopPropagation();        
            event.preventDefault();         
            $container.find('.nps-second-step').show();           
            $container.find('.nps-first-step').hide();     
        });   */
    }); 
    
    jQuery.wsko_init_misc_widgets = function()
    {
        $('.wsko-misc-content-table').each(function(index){
            var $this = $(this),
            $target = $this.find('.wsko-misc-content-table-target'),
            $table_wrapper = $('<div class="wsko-misc-content-table-wrapper"><ol class="wsko-misc-content-table-gen"></ol></div>'),
            $table = $table_wrapper.find('ol'),
            $headings = [],
            level = 1,
            $cur = null;
            $this.find('h1,h2,h3,h4,h5,h6').each(function(index){
                var $el = $(this),
                dl = parseInt($el.prop("tagName").toLowerCase().replace("h","")),
                $link = $('<a href="#" class="wsko-misc-content-table-link">'+$el.text()+'</a>');
                $link.data('target', $el);
                if (index && dl != 1)
                {
                    if (level < dl)
                    {
                        level++;
                        dl = level;
                        $cur = $('<li><ol></ol></li>').appendTo($cur.find('ol'));
                        $cur.prepend($link);
                    }
                    else if (level > dl)
                    {
                        for (var i = level; i > dl; i--)
                        {
                            $cur = $cur.parent().closest('li');
                        }
                        $cur = $('<li><ol></ol></li>').appendTo($cur.closest('ol'));
                        $cur.prepend($link);
                    }
                    else
                    {
                        $cur = $('<li><ol></ol></li>').appendTo($cur.closest('ol'));
                        $cur.prepend($link);
                    }
                }
                else
                {
                    $cur = $('<li><ol></ol></li>').appendTo($table);
                    $cur.prepend($link);
                }
                level = dl;
            })
            if ($target.length)
                $target.append($table_wrapper).removeClass('wsko-misc-content-table-target');
            else
                $this.prepend($table_wrapper);
            $this.removeClass('wsko-misc-content-table');
        });
        $('.wsko-misc-content-table-link:not(.wsko-init)').addClass('wsko-init').click(function(event){
            event.preventDefault();
            var $this = $(this);
            
            $(wsko_get_scroll_parent($this.get(0))).animate({
                scrollTop: $this.data('target').offset().top
            }, 500);
        });
    }

    function wsko_get_scroll_parent(element, includeHidden) {
        var style = getComputedStyle(element);
        var excludeStaticParent = style.position === "absolute";
        var overflowRegex = includeHidden ? /(auto|scroll|hidden)/ : /(auto|scroll)/;
    
        if (style.position === "fixed") return document.body;
        for (var parent = element; (parent = parent.parentElement);) {
            style = getComputedStyle(parent);
            if (excludeStaticParent && style.position === "static") {
                continue;
            }
            if (overflowRegex.test(style.overflow + style.overflowY + style.overflowX)) return parent;
        }
    
        return document.body;
    }
});