<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}
$post_id = ( isset( $template_args['post_id'] ) ? $template_args['post_id'] : false );
$widget = ( isset( $template_args['widget'] ) && $template_args['widget'] ? true : false );
$keywords = ( isset( $template_args['keywords'] ) ? $template_args['keywords'] : false );
$page_data = ( isset( $template_args['page_data'] ) ? $template_args['page_data'] : false );
$kw_count = ( isset( $template_args['kw_count'] ) ? $template_args['kw_count'] : false );
$kw_count_ref = ( isset( $template_args['kw_count_ref'] ) ? $template_args['kw_count_ref'] : false );
$preview = ( isset( $template_args['preview'] ) ? $template_args['preview'] : false );
$open_tab = ( isset( $template_args['open_tab'] ) ? $template_args['open_tab'] : false );
$uniqid = WSKO_Class_Helper::get_unique_id();

if ( $post_id ) {
    $keywords_available = WSKO_Controller_Search::get_instance()->is_accessible( 'overview' );
    $backlinks_available = false;
    $linking_available = false;
    $performance_available = false;
    //global $post;
    $post = get_post( $post_id );
    $title_o = get_the_title( $post->ID );
    $content = ( $preview && $preview['post_content'] ? $preview['post_content'] : $post->post_content );
    $title = ( $preview && $preview['post_title'] ? $tile_o = $preview['post_title'] : $post->post_title );
    $slug = ( $preview && $preview['post_slug'] ? $preview['post_slug'] : $post->post_name );
    $link = get_permalink( $post_id );
    $edit_link = get_edit_post_link( $post_id );
    $op_report = WSKO_Class_Onpage::get_onpage_report( $post_id, $preview );
    $priority_keywords = WSKO_Class_Onpage::get_priority_keywords( $post_id );
    $priority_keywords_count = 0;
    
    if ( $priority_keywords ) {
        foreach ( $priority_keywords as $pk => $pk_data ) {
            
            if ( isset( $op_report['issues']['keyword_density'][$pk] ) ) {
                $priority_keywords[$pk]['den'] = $op_report['issues']['keyword_density'][$pk]['density'];
                $priority_keywords[$pk]['den_type'] = $op_report['issues']['keyword_density'][$pk]['type'];
            }
        
        }
        $priority_keywords_count = count( $priority_keywords );
    }
    
    $t_seo_data = WSKO_Class_Onpage::get_technical_seo_data( $post_id );
    $table_keywords = array();
    $max_t_kw_clicks = 0;
    $max_t_kw_pos = 0;
    $max_t_kw_impr = 0;
    $max_t_kw_ctr = 0;
    $max_t_kw_sv = 0;
    $max_t_kw_cpc = 0;
    if ( $keywords ) {
        foreach ( $keywords as $kw ) {
            $kw_data = array(
                'clicks' => '-',
                'pos'    => '-',
                'kw_den' => '-',
            );
            
            if ( isset( $priority_keywords[$kw->keyval] ) ) {
                $priority_keywords[$kw->keyval]['clicks'] = $kw->clicks;
                $priority_keywords[$kw->keyval]['pos'] = $kw->position;
            }
            
            $data_arr = array(
                array(
                'value' => $kw->keyval,
            ),
                array(
                'order' => $kw->position,
                'value' => WSKO_Class_Helper::format_number( $kw->position ) . (( $kw->position_ref != null ? WSKO_Class_Template::render_progress_icon(
                round( abs( $kw->position_ref - $kw->position ), 2 ),
                WSKO_Class_Helper::get_ref_value( $kw->position, $kw->position_ref ),
                array(
                'absolute' => true,
                'tooltip'  => $kw->position_ref,
            ),
                true
            ) : '' )),
            ),
                array(
                'order' => $kw->clicks,
                'value' => WSKO_Class_Helper::format_number( $kw->clicks ) . (( $kw->clicks_ref != null ? WSKO_Class_Template::render_progress_icon(
                $kw->clicks_ref,
                WSKO_Class_Helper::get_ref_value( $kw->clicks, $kw->clicks_ref ),
                array(),
                true
            ) : '' )),
            ),
                array(
                'order' => $kw->impressions,
                'value' => WSKO_Class_Helper::format_number( $kw->impressions ) . (( $kw->impressions_ref != null ? WSKO_Class_Template::render_progress_icon(
                $kw->impressions_ref,
                WSKO_Class_Helper::get_ref_value( $kw->impressions, $kw->impressions_ref ),
                array(),
                true
            ) : '' )),
            ),
                array(
                'order' => $kw->ctr,
                'value' => round( $kw->ctr, 2 ) . '%' . (( $kw->ctr_ref != null ? WSKO_Class_Template::render_progress_icon(
                $kw->ctr_ref,
                WSKO_Class_Helper::get_ref_value( round( $kw->ctr, 2 ), $kw->ctr_ref ),
                array(),
                true
            ) : '' )),
            )
            );
            if ( $kw->position > $max_t_kw_pos ) {
                $max_t_kw_pos = $kw->position;
            }
            if ( $kw->clicks > $max_t_kw_clicks ) {
                $max_t_kw_clicks = $kw->clicks;
            }
            if ( $kw->impressions > $max_t_kw_impr ) {
                $max_t_kw_impr = $kw->impressions;
            }
            if ( $kw->ctr > $max_t_kw_ctr ) {
                $max_t_kw_ctr = $kw->ctr;
            }
            $data_arr[] = array(
                'value' => '<a href="#" class="wsko-co-add-priority-keyword-inline dark" data-toggle="tooltip" data-title="Add to Priority Keywords" data-post="' . $post_id . '" data-keyword="' . $kw->keyval . '" data-prio="" data-nonce="' . wp_create_nonce( 'wsko_co_add_priority_keyword' ) . '"><i class="fa fa-plus fa-fw"></i></a>',
            );
            $table_keywords[] = $data_arr;
        }
    }
    $keyword_filters = array(
        '1' => array(
        'title' => 'Position',
        'type'  => 'number_range',
        'max'   => $max_t_kw_pos,
    ),
        '2' => array(
        'title' => 'Clicks',
        'type'  => 'number_range',
        'max'   => $max_t_kw_clicks,
    ),
        '3' => array(
        'title' => 'Impressions',
        'type'  => 'number_range',
        'max'   => $max_t_kw_impr,
    ),
    );
    $sitemap_excluded = false;
    $gen_params = WSKO_Class_Onpage::get_sitemap_params();
    if ( isset( $gen_params['excluded_posts'] ) && is_array( $gen_params['excluded_posts'] ) && $gen_params['excluded_posts'] ) {
        $sitemap_excluded = $gen_params['excluded_posts'] && in_array( $post_id, $gen_params['excluded_posts'] );
    }
    $crawl_data = WSKO_Class_Onpage::get_onpage_page_crawl_data( $link );
    ?>
	<div class="wsko-content-optimizer wsko_wrapper <?php 
    echo  ( $widget ? 'wsko-co-widget wsko-short-view-active' : 'wsko-co-modal' ) ;
    ?>">
		<?php 
    
    if ( !$widget ) {
        ?><div class="wsko-co-onpage-score-wrapper pull-right" style="position:relative; width: 240px;"><?php 
        WSKO_Class_Template::render_template( 'content-optimizer/template-co-score.php', array(
            'op_report'  => $op_report,
            'crawl_data' => $crawl_data,
        ) );
        ?>
			</div>
			<div class="panel-heading wsko-bg-gray">
				<h4 style="margin:5px 0px 0px;"><?php 
        echo  ( $title_o ? esc_html( $title_o ) : WSKO_Class_Helper::get_empty_page_title() ) ;
        ?> <a class="wsko-small dark" target="_blank" href="<?php 
        echo  $edit_link ;
        ?>"><i class="fa fa-pencil text-off fa-fw"></i></a></h4>
				<span class="wsko-text-off wsko-small"><a class="dark" href="<?php 
        echo  $link ;
        ?>"><?php 
        echo  $link ;
        ?></a><span class="wsko-mr3 wsko-ml3"> • </span> <span>Last edited: <?php 
        echo  get_post_modified_time( 'd.m.Y H:i', true, $post_id ) ;
        ?></span>
			</div>
			<?php 
    } else {
        $box_height = WSKO_Class_Core::get_option( 'co_box_height_' . get_current_user_id() );
        ?><div class="wsko-resizable-wrapper wsko_wrapper" style="min-height:200px;max-height:300px;height:<?php 
        echo  ( $box_height ? $box_height : '0' ) ;
        ?>px" data-height="<?php 
        echo  ( $box_height ? $box_height : '0' ) ;
        ?>" data-nonce="<?php 
        echo  wp_create_nonce( 'wsko_co_change_height' ) ;
        ?>">
				<div style="position:relative;height:100%;overflow-y:auto;overflow-x:hidden;" class="wsko-resizable-content"><?php 
    }
    
    ?>
			<div class="wsko-shadow <?php 
    echo  ( $widget ? '' : 'wsko-bg-gray' ) ;
    ?>">
				<ul class="wsko-nav wsko-nav-main bsu-tabs" <?php 
    echo  ( $widget ? 'style="display:none;"' : '' ) ;
    ?>>
				  <li><a class="wsko-nav-link <?php 
    echo  ( !$open_tab ? 'wsko-nav-link-active' : '' ) ;
    ?>" href="#wsko_overview_<?php 
    echo  $uniqid ;
    ?>"><?php 
    echo  __( 'Overview', 'wsko' ) ;
    ?></a></li>
				  <li><a class="wsko-nav-link <?php 
    echo  ( $open_tab === 'metas' ? 'wsko-nav-link-active' : '' ) ;
    ?>" href="#wsko_metas_<?php 
    echo  $uniqid ;
    ?>"><?php 
    echo  __( 'Metas & Snippets', 'wsko' ) ;
    ?></a></li>
				  <?php 
    /* <li><a class="wsko-nav-link <?=$open_tab === 'social' ?  'wsko-nav-link-active' : ''?>" href="#wsko_snippets_<?=$uniqid?>"><?=__( 'Social Snippets', 'wsko' ) ?></a></li> */
    ?>
				  <li><a class="wsko-nav-link <?php 
    echo  ( $open_tab === 'keywords' ? 'wsko-nav-link-active' : '' ) ;
    ?>" href="#wsko_keywords_<?php 
    echo  $uniqid ;
    ?>"><?php 
    echo  __( 'Keywords', 'wsko' ) ;
    ?></a></li>
				  <?php 
    
    if ( !$widget ) {
        ?><li><a class="wsko-nav-link <?php 
        echo  ( $open_tab === 'content' ? 'wsko-tab-active' : '' ) ;
        ?>" href="#wsko_content_<?php 
        echo  $uniqid ;
        ?>"><?php 
        echo  __( 'Content', 'wsko' ) ;
        ?></a></li><?php 
    }
    
    ?>
				  <?php 
    ?>
					<li><a class="wsko-nav-link <?php 
    echo  ( $open_tab === 'technical' ? 'wsko-nav-link-active' : '' ) ;
    ?>" href="#wsko_technical_<?php 
    echo  $uniqid ;
    ?>"><?php 
    echo  __( 'Advanced', 'wsko' ) ;
    ?></a></li>
				</ul>
				<?php 
    if ( $widget ) {
        ?>
					<a href="#" class="wsko-resizable-wrapper-quick-up dark wsko-co-collapse-top text-off">
						<i class="fa fa-times fa-fw"></i> 
					</a>
					<a href="#" class="wsko-resizable-wrapper-quick-down dark wsko-co-collapse-top text-off">
						<i class="fa fa-arrows-alt fa-fw"></i>
					</a>
				<?php 
    }
    ?>	
			</div>	
			<div class="wsko-co-main <?php 
    echo  ( $widget ? 'mt15' : 'm15' ) ;
    ?>">	
				<div class="wsko-row">
					<div class="wsko-co-notifications-overlay" style="display:none;"></div>
				</div>	
				<div class="wsko-row" style="margin-right:-13px;margin-left:-13px;">
					<div class="wsko-col-sm-8 wsko-col-xs-12 wsko-widget-main">
						<div class="wsko-tab-content wsko-content-optimizer-inner">
						 
						  <div id="wsko_overview_<?php 
    echo  $uniqid ;
    ?>" class="wsko-tab <?php 
    echo  ( !$open_tab ? 'wsko-tab-active' : '' ) ;
    ?>">
								<div class="wsko-content-optimizer-overview">
									<?php 
    /* WSKO_Class_Template::render_template('onpage/view-url-check.php', array('url' => $link, 'suppress_success' => true)); */
    ?>
									<?php 
    /*if (!$keywords_available) { WSKO_Class_Template::render_notification('info', array('msg' => 'Search API is not connected. '.
    			WSKO_Class_Template::render_page_link(WSKO_Controller_Search::get_instance(), '', 'See more', array('button' => false), true)));  } 
    		if (wsko_fs()->is__premium_only()) {
    			if (wsko_fs()->can_use_premium_code()) { 
    				if (!$backlinks_available || !$performance_available) { WSKO_Class_Template::render_notification('info', array('msg' => 'Analytics API is not connected. '.
    					WSKO_Class_Template::render_page_link(WSKO_Controller_Backlinks::get_instance(), '', 'See more', array('button' => false), true))); }
    				if (!$linking_available || !$performance_available) { WSKO_Class_Template::render_notification('info', array('msg' => 'Your Onpage crawl (Premium) is not finished. '.
    					WSKO_Class_Template::render_page_link(WSKO_Controller_Onpage::get_instance(), '', 'See more', array('button' => false), true)));  } 
    			}
    		} */
    ?>
									<div class="wsko-row wsko-overview-hero-wrapper">
									  <?php 
    WSKO_Class_Template::render_panel( array(
        'type'   => 'hero-custom',
        'fa'     => '',
        'title'  => __( 'Keywords', 'wsko' ),
        'col'    => 'wsko-col-sm-3 wsko-col-xs-6 col-sm-3 col-xs-6',
        'custom' => ( $keywords ? WSKO_Class_Helper::format_number( $kw_count ) . (( $kw_count_ref != null ? WSKO_Class_Template::render_progress_icon(
        $kw_count_ref,
        WSKO_Class_Helper::get_ref_value( $kw_count, $kw_count_ref ),
        array(
        'decimals' => 2,
    ),
        true
    ) : '' )) : '-' ),
    ) );
    WSKO_Class_Template::render_panel( array(
        'type'   => 'hero-custom',
        'fa'     => '',
        'title'  => __( 'Klicks', 'wsko' ),
        'col'    => 'wsko-col-sm-3 wsko-col-xs-6 col-sm-3 col-xs-6',
        'custom' => ( $page_data ? WSKO_Class_Helper::format_number( $page_data->clicks ) . (( $page_data->clicks_ref != null ? WSKO_Class_Template::render_progress_icon(
        $page_data->clicks_ref,
        WSKO_Class_Helper::get_ref_value( $page_data->clicks, $page_data->clicks_ref ),
        array(
        'decimals' => 2,
    ),
        true
    ) : '' )) : '-' ),
    ) );
    WSKO_Class_Template::render_panel( array(
        'type'   => 'hero-custom',
        'fa'     => '',
        'title'  => __( 'Impressions', 'wsko' ),
        'col'    => 'wsko-col-sm-3 wsko-col-xs-6 col-sm-3 col-xs-6',
        'custom' => ( $page_data ? WSKO_Class_Helper::format_number( $page_data->impressions ) . (( $page_data->impressions_ref != null ? WSKO_Class_Template::render_progress_icon(
        $page_data->impressions_ref,
        WSKO_Class_Helper::get_ref_value( $page_data->impressions, $page_data->impressions_ref ),
        array(
        'decimals' => 2,
    ),
        true
    ) : '' )) : '-' ),
    ) );
    WSKO_Class_Template::render_panel( array(
        'type'   => 'hero-custom',
        'fa'     => '',
        'title'  => __( 'Avg. Position', 'wsko' ),
        'col'    => 'wsko-col-sm-3 wsko-col-xs-6 col-sm-3 col-xs-6',
        'custom' => ( $page_data ? WSKO_Class_Helper::format_number( $page_data->position ) . (( $page_data->position_ref != null ? WSKO_Class_Template::render_progress_icon(
        round( abs( $page_data->position_ref - $page_data->position ), 2 ),
        -WSKO_Class_Helper::get_ref_value( $page_data->position, $page_data->position_ref ),
        array(
        'decimals' => 2,
        'absolute' => true,
        'tooltip'  => $page_data->position_ref,
    ),
        true
    ) : '' )) : '-' ),
    ) );
    ?>
									</div>
									<?php 
    WSKO_Class_Template::render_template( 'content-optimizer/template-co-issues.php', array(
        'op_report' => $op_report,
    ) );
    ?>
								</div>	
						  </div>

						  <div id="wsko_metas_<?php 
    echo  $uniqid ;
    ?>" class="wsko-tab <?php 
    echo  ( $open_tab === 'metas' ? 'wsko-tab-active' : '' ) ;
    ?>">
							<?php 
    
    if ( WSKO_Class_Onpage::seo_plugins_disabled() ) {
        WSKO_Class_Template::render_template( 'template-metas-view.php', array(
            'meta_view' => 'co',
            'post_id'   => $post_id,
            'type'      => 'post_id',
        ) );
    } else {
        WSKO_Class_Template::render_template( 'template-seo-plugins-disable.php', array() );
    }
    
    ?>
						  </div>
						
						<?php 
    /*
      <div id="wsko_snippets_<?=$uniqid?>" class="wsko-tab <?=$open_tab === 'social' ?  'wsko-tab-active' : ''?>">
    	<?php 
    	if (WSKO_Class_Onpage::seo_plugins_disabled())
    	{
    		WSKO_Class_Template::render_template('template-metas-view.php', array('meta_view' => 'social', 'post_id' => $post_id, 'type' => 'post_id'));
    	}	
    	else
    	{
    		WSKO_Class_Template::render_template('template-seo-plugins-disable.php', array());
    	} ?>
      </div>
    */
    ?>
						  <div id="wsko_keywords_<?php 
    echo  $uniqid ;
    ?>" class="wsko-tab <?php 
    echo  ( $open_tab === 'keywords' ? 'wsko-tab-active' : '' ) ;
    ?>">
						 	 <?php 
    
    if ( $keywords_available ) {
        ?>
								<ul class="wsko-nav bsu-tabs bsu-tabs-sm">
									<li><a href="#wsko_co_keywords_rankings" class="wsko-nav-link wsko-nav-link-active">Ranking Keywords</a></li>
									<li><a href="#wsko_co_keywords_histories" class="wsko-nav-link">Ranking Histories</a></li>
									<?php 
        ?>	
								</ul>
								<div class="wsko-tab-content">
									<div id="wsko_co_keywords_rankings" class="wsko-tab wsko-tab-active">
										<?php 
        
        if ( !WSKO_Class_Core::get_option( 'search_query_first_run' ) ) {
            WSKO_Class_Template::render_notification( 'warning', array(
                'msg' => 'Your search data is being updated. Keywords are available after the first report is finished.',
            ) );
        } else {
            
            if ( $keywords ) {
                $keyword_headers = array(
                    'Keyword',
                    'Pos',
                    'Clicks',
                    'Impr',
                    'CTR'
                );
                $keyword_headers[] = '';
                WSKO_Class_Template::render_table( $keyword_headers, $table_keywords, array(
                    'order'  => array(
                    'col' => '2',
                    'dir' => 'desc',
                ),
                    'filter' => $keyword_filters,
                ) );
            } else {
                WSKO_Class_Template::render_template( 'template-no-data.php', array() );
            }
        
        }
        
        ?>
									</div>
									<div id="wsko_co_keywords_histories" class="wsko-tab">
											<?php 
        $clicks_hist = WSKO_Class_Core::get_post_data_history( $post_id, 'search_clicks' );
        $pos_hist = WSKO_Class_Core::get_post_data_history( $post_id, 'search_pos' );
        $imp_hist = WSKO_Class_Core::get_post_data_history( $post_id, 'search_imp' );
        $ctr_hist = WSKO_Class_Core::get_post_data_history( $post_id, 'search_ctr' );
        if ( $clicks_hist ) {
            foreach ( $clicks_hist as $k => $hist ) {
                $k_v = date( 'M. d, Y', $k );
                $clicks_hist[$k] = array( array(
                    'v' => $k_v,
                    'f' => $k_v,
                ), array(
                    'v' => $hist,
                    'f' => WSKO_Class_Helper::format_number( $hist ),
                ) );
            }
        }
        if ( $pos_hist ) {
            foreach ( $pos_hist as $k => $hist ) {
                $k_v = date( 'M. d, Y', $k );
                $pos_hist[$k] = array( array(
                    'v' => $k_v,
                    'f' => $k_v,
                ), array(
                    'v' => $hist,
                    'f' => WSKO_Class_Helper::format_number( $hist ),
                ) );
            }
        }
        if ( $imp_hist ) {
            foreach ( $imp_hist as $k => $hist ) {
                $k_v = date( 'M. d, Y', $k );
                $imp_hist[$k] = array( array(
                    'v' => $k_v,
                    'f' => $k_v,
                ), array(
                    'v' => $hist,
                    'f' => WSKO_Class_Helper::format_number( $hist ),
                ) );
            }
        }
        if ( $ctr_hist ) {
            foreach ( $ctr_hist as $k => $hist ) {
                $k_v = date( 'M. d, Y', $k );
                $ctr_hist[$k] = array( array(
                    'v' => $k_v,
                    'f' => $k_v,
                ), array(
                    'v' => $hist,
                    'f' => WSKO_Class_Helper::format_number( $hist ),
                ) );
            }
        }
        ?>
												<ul class="wsko-nav bsu-tabs bsu-tabs-sm">
													<li><a href="#ext_search_tab_clicks" class="wsko-nav-link wsko-nav-link-active">Clicks History</a></li>
													<li><a href="#ext_search_tab_pos" class="wsko-nav-link">Position History</a></li>
													<li><a href="#ext_search_tab_imp" class="wsko-nav-link">Impressions History</a></li>
													<li><a href="#ext_search_tab_ctr" class="wsko-nav-link">CTR History</a></li>
												</ul>    
												<div class="wsko-tab-content">
													<div id="ext_search_tab_clicks" class="wsko-tab wsko-tab-active">
														<?php 
        WSKO_Class_Template::render_chart(
            'area',
            array( 'Date', 'Clicks' ),
            $clicks_hist,
            array(
            'axisTitleY'  => 'Clicks',
            'chart_left'  => '15',
            'chart_width' => '70',
        ),
            false
        );
        ?>
													</div>
													<div id="ext_search_tab_pos" class="wsko-tab">
														<?php 
        WSKO_Class_Template::render_chart(
            'area',
            array( 'Date', 'Position' ),
            $pos_hist,
            array(
            'axisTitleY'  => 'Position',
            'chart_left'  => '15',
            'chart_width' => '70',
        ),
            false
        );
        ?>
													</div>
													<div id="ext_search_tab_imp" class="wsko-tab">
														<?php 
        WSKO_Class_Template::render_chart(
            'area',
            array( 'Date', 'Impressions' ),
            $imp_hist,
            array(
            'axisTitleY'  => 'Impressions',
            'chart_left'  => '15',
            'chart_width' => '70',
        ),
            false
        );
        ?>
													</div>
													<div id="ext_search_tab_ctr" class="wsko-tab">
														<?php 
        WSKO_Class_Template::render_chart(
            'area',
            array( 'Date', 'CTR' ),
            $ctr_hist,
            array(
            'axisTitleY'  => 'CTR',
            'chart_left'  => '15',
            'chart_width' => '70',
        ),
            false
        );
        ?>
													</div>
												</div>
												<?php 
        ?>
									</div>
									<?php 
        ?>	
								</div><?php 
    } else {
        WSKO_Class_Template::render_notification( 'info', array(
            'msg' => 'Search API is not connected. ' . WSKO_Class_Template::render_page_link(
            WSKO_Controller_Search::get_instance(),
            '',
            'See more',
            array(
            'button' => false,
        ),
            true
        ),
        ) );
    }
    
    ?>
						  </div>

						  <div id="wsko_technical_<?php 
    echo  $uniqid ;
    ?>" class="wsko-co-advanced wsko-tab <?php 
    echo  ( $open_tab === 'technical' ? 'wsko-tab-active' : '' ) ;
    ?>">
							<div class="form-group wsko-row">
								<div class="wsko-col-sm-3 wsko-col-xs-12">
									<p>Canonical Tag</p>
								</div>
								<div class="wsko-col-sm-9 wsko-col-xs-12">
									<?php 
    WSKO_Class_Template::render_template( 'template-metas-view.php', array(
        'meta_view' => 'canonical',
        'post_id'   => $post_id,
        'type'      => 'post_id',
    ) );
    ?>
								</div>	
							</div>	
							<?php 
    
    if ( WSKO_Class_Onpage::seo_plugins_disabled() ) {
        ?>
							<div class="wsko-border wsko-mb10 wsko-mt10"></div>
							<div class="form-group wsko-row">
								<div class="wsko-col-sm-3 wsko-col-xs-12">
									<p>Sitemap Generation</p>
								</div>
								<div class="wsko-col-sm-9 wsko-col-xs-12">
									<label><input class="form-control wsko-ajax-input" type="checkbox" <?php 
        echo  ( $sitemap_excluded ? 'checked="checked"' : '' ) ;
        ?> data-wsko-target="onpage_sitemap_post_exclude" data-wsko-setting="<?php 
        echo  $post_id ;
        ?>"> Exclude from Sitemap</label>
								</div>	
							</div>
							<?php 
    }
    
    ?>
							<div class="wsko-border wsko-mb10 wsko-mt10"></div>
							<div class="wsko-co-technical-wrapper" data-post="<?php 
    echo  $post_id ;
    ?>" data-nonce="<?php 
    echo  wp_create_nonce( 'wsko_co_save_technicals' ) ;
    ?>">
								<div class="form-group wsko-row">
									<div class="wsko-col-sm-3 wsko-col-xs-12">						
										<p>Redirect To</p>
									</div>
									<div class="wsko-col-sm-9 wsko-col-xs-12">
										<p><label><input class="wsko-co-redirect-activate wsko-form-control" type="checkbox" <?php 
    echo  ( isset( $t_seo_data['redirect'] ) && $t_seo_data['redirect'] ? 'checked' : '' ) ;
    ?>> Activate Redirect</label></p>
										<input class="wsko-co-redirect-to wsko-form-control wsko-mb10" type="text" placeholder="/relative/link/ or https://external-domain.com/path " value="<?php 
    echo  ( isset( $t_seo_data['redirect']['to'] ) ? $t_seo_data['redirect']['to'] : '' ) ;
    ?>">
										<select class="wsko-co-redirect-type wsko-form-control wsko-mb10">
											<option value="1" <?php 
    echo  ( isset( $t_seo_data['redirect']['type'] ) && $t_seo_data['redirect']['type'] == '1' ? 'selected' : '' ) ;
    ?>>301 (Permanent Redirect, SEO fiendly)</option>
											<option value="2" <?php 
    echo  ( isset( $t_seo_data['redirect']['type'] ) && $t_seo_data['redirect']['type'] == '2' ? 'selected' : '' ) ;
    ?>>302 (Temporary Redirect)</option>
										</select>
									</div>	
								</div>
								
								<div class="wsko-border wsko-mb10 wsko-mt10"></div>
								
								<div class="form-group wsko-row wsko-co-redirect-from-wrapper">
									<div class="wsko-col-sm-3 wsko-col-xs-12">
										<p>Redirects from this post</p>
            							<small class="wsko-text-off">Lists <?php 
    WSKO_Class_Template::render_page_link(
        WSKO_Controller_Tools::get_instance(),
        "links",
        'redirect rules',
        array(
        'button' => false,
    ),
        false
    );
    ?> that match this post's url.</small>
									</div>
									<div class="wsko-col-sm-9 wsko-col-xs-12">									
										<div class="wsko-row">
											<div class="wsko-col-sm-12 wsko-col-xs-12">	
												<?php 
    WSKO_Class_Template::render_ajax_beacon( 'wsko_check_redirect', array(
        'post' => array(
        'url'          => $link,
        'status_check' => false,
    ),
    ) );
    ?>
											</div>
										</div>
									</div>
								</div>			
								
								<div class="wsko-border wsko-mb10 wsko-mt10"></div>
								
								<div class="form-group wsko-row">
									<div class="wsko-col-sm-3 wsko-col-xs-12">
										<p>Auto Post Redirects</p>
										<small class="wsko-text-off">Lists <?php 
    WSKO_Class_Template::render_page_link(
        WSKO_Controller_Tools::get_instance(),
        "links",
        'automatic redirects',
        array(
        'button' => false,
    ),
        false
    );
    ?> from the posts old urls to its current url.</small>
									</div>
									<div class="wsko-col-sm-9 wsko-col-xs-12">	
										<?php 
    $redirects = WSKO_Class_Onpage::get_auto_redirects( 'post_id' );
    
    if ( $redirects && isset( $redirects[$post_id] ) ) {
        $redirects = $redirects[$post_id];
        
        if ( $redirects ) {
            $reds = array();
            foreach ( $redirects as $key => $red ) {
                $reds[] = '<i>' . $red . '</i> ' . (( current_user_can( 'manage_options' ) ? WSKO_Class_Template::render_ajax_button(
                    '<i class="fa fa-times"></i>',
                    'remove_auto_redirect',
                    array(
                    'type' => 'post_id',
                    'arg'  => $post_id,
                    'key'  => $key,
                ),
                    array(),
                    true
                ) : '' ));
            }
            WSKO_Class_Template::render_notification( 'warning', array(
                'msg'         => 'This post has redirects from old links:',
                'list'        => $reds,
                'notif-class' => 'wsko-post-redirects',
            ) );
        } else {
            WSKO_Class_Template::render_notification( 'info', array(
                'msg' => 'No redirects found.',
            ) );
        }
    
    } else {
        WSKO_Class_Template::render_notification( 'info', array(
            'msg' => 'No redirects found.',
        ) );
    }
    
    ?>
									</div>
								</div>			
							</div>
						</div>

						  <?php 
    
    if ( !$widget ) {
        ?>
							  <div id="wsko_content_<?php 
        echo  $uniqid ;
        ?>" class="wsko-tab <?php 
        echo  ( $open_tab === 'content' ? 'wsko-tab-active' : '' ) ;
        ?>">
								<div class="wsko-co-update-content">
									<?php 
        echo  WSKO_Class_Template::render_form( array(
            'type'      => 'input',
            'title'     => 'Post Title',
            'value'     => $title,
            'class'     => 'wsko-co-content-field-title wsko-form-control',
            'nonce'     => 'wsko_co_save_content',
            'fullWidth' => true,
        ) ) ;
        ?>
									<?php 
        echo  WSKO_Class_Template::render_form( array(
            'type'      => 'input',
            'title'     => 'Post Slug',
            'value'     => $slug,
            'class'     => 'wsko-co-content-field-slug wsko-form-control',
            'nonce'     => 'wsko_co_save_content',
            'fullWidth' => true,
        ) ) ;
        ?>
									<?php 
        /* =WSKO_Class_Template::render_form(array('type' => 'textarea', 'title' => 'Post Content', 'value' => $content, 'class' => 'wsko-co-content-field-content wsko-form-control', 'nonce' => 'wsko_co_save_content', 'rows' => '15', 'fullWidth' => true)); */
        ?>
									<?php 
        echo  WSKO_Class_Template::render_form( array(
            'type'      => 'editor',
            'title'     => 'Post Content',
            'value'     => $content,
            'class'     => 'wsko-co-content-field-content wsko-form-control',
            'nonce'     => 'wsko_co_save_content',
            'rows'      => '15',
            'fullWidth' => true,
        ) ) ;
        ?>
									<?php 
        echo  WSKO_Class_Template::render_form( array(
            'type'      => 'submit',
            'title'     => '',
            'value'     => $content,
            'class'     => 'wsko-co-save-content',
            'nonce'     => 'wsko_co_save_content',
            'data-post' => $post_id,
            'fullWidth' => true,
        ) ) ;
        ?>
								</div>
							  </div>
						  <?php 
    }
    
    ?>
						<?php 
    ?>
						</div>
					</div>
					<div class="wsko-col-sm-4 wsko-col-xs-12 wsko-widget-sidebar">
						<?php 
    
    if ( $widget ) {
        ?>
							<div class="wsko-co-progress-wrapper wsko-align-center wsko-mb10" style="position:relative;">
								<?php 
        WSKO_Class_Template::render_radial_progress( 'success', __( 'Content Score', 'wsko' ), array(
            'val'   => ( $op_report ? $op_report['onpage_score'] : '-' ),
            'class' => 'wsko-inline-block hidden-xs',
        ) );
        ?>
							</div>
						<?php 
    }
    
    ?>	
						<div class="wsko-sidebar-keywords-view">
							<?php 
    WSKO_Class_Template::render_template( 'content-optimizer/template-co-sidebar-keywords.php', array(
        'post_id'           => $post_id,
        'priority_keywords' => $priority_keywords,
        'keyword_data'      => $keywords,
        'op_report'         => $op_report,
    ) );
    ?>
						</div>
					</div>
				</div>	
				<div class="clearfix">
				</div>
			</div>	
		<?php 
    if ( $widget ) {
        ?>
				</div>
				<div class="wsko-co-control-wrapper wsko-align-center">
					<div class="wsko-rezisable-wrapper-thumb text-off" style="margin-right: 15px;">
						<i class="fa fa-expand fa-fw"></i> Drag
					</div>
					<a href="#" class="wsko-resizable-wrapper-quick-down dark text-off">
						<i class="fa fa-arrows-alt fa-fw"></i> Expand
					</a>
					<a href="#" class="wsko-resizable-wrapper-quick-up dark text-off">
						<i class="fa fa-times"></i> Collapse
					</a>					
				</div>	
			</div><?php 
    }
    ?>
		<?php 
    /* <a class="wsko-expand-content-optimizer-link wsko-co-expand-icon dark text-off" href="#"><span class="wsko-expand-content-optimizer"><i class="fa fa-angle-down fa-fw fa-2x"></i></span></a>
    		<p class="wsko-align-center" style="margin-bottom:0px;"><a class="wsko-expand-content-optimizer-link wsko-co-expand-icon-close dark text-off" href="#"><span class="wsko-expand-content-optimizer"><i class="fa fa-angle-up fa-fw fa-2x"></i></span></a></p> */
    ?>
		<!--div class="wsko-co-notifications-overlay" style="position:absolute;bottom:10px;right:10px;"></div-->
	</div>
	<?php 
} else {
    ?>Post ID not set!<?php 
}
