<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}
$global_analysis = WSKO_Class_Onpage::get_onpage_analysis();
$analysis = ( isset( $global_analysis['current_report'] ) ? $global_analysis['current_report'] : false );
$header_link_table = array(
    'CS' . WSKO_Class_Template::render_infoTooltip( 'Content Score', 'info', true ),
    'Page',
    array(
    'name'  => 'URL Length',
    'width' => '15%',
),
    array(
    'name'  => '',
    'width' => '5%',
)
);
$filter_link_table = array(
    'onpage_score' => array(
    'title' => 'Onpage Score',
    'type'  => 'number_range',
    'max'   => $analysis['max']['onpage_score'],
),
    'url'          => array(
    'title' => 'URL',
    'type'  => 'text',
),
    'post_type'    => array(
    'title'  => 'Post Type',
    'type'   => 'select',
    'values' => ( isset( $analysis['post_types'] ) ? WSKO_Class_Helper::get_post_type_labels( $analysis['post_types'] ) : array() ),
),
    'url_length'   => array(
    'title' => 'URL Length',
    'type'  => 'number_range',
    'max'   => $analysis['max']['url_length'],
),
);
$order = array(
    'col' => 2,
    'dir' => 'desc',
);
?>
<div class="row">
	<?php 
WSKO_Class_Template::render_panel( array(
    'type'  => 'progress',
    'title' => 'URL Length',
    'col'   => 'col-sm-12 col-xs-12',
    'items' => array( array(
    'title'          => __( 'OK', 'wsko' ),
    'tooltip'        => $analysis['url_length_dist']['ok'] . ' Pages',
    'value'          => $analysis['url_length_dist']['ok'],
    'max'            => $analysis['total_pages'],
    'progress_class' => 'success',
    'class'          => 'wsko-external-table-filter',
    'data'           => array(
    'table' => '#wsko_onpage_analysis_permalink_table',
    'val'   => 'url_length:0:' . (WSKO_ONPAGE_URL_MAX - 1),
),
), array(
    'title'          => __( 'Too Long', 'wsko' ),
    'tooltip'        => $analysis['url_length_dist']['too_long'] . ' Pages',
    'value'          => $analysis['url_length_dist']['too_long'],
    'max'            => $analysis['total_pages'],
    'progress_class' => 'warning',
    'class'          => 'wsko-external-table-filter',
    'data'           => array(
    'table' => '#wsko_onpage_analysis_permalink_table',
    'val'   => 'url_length:' . (WSKO_ONPAGE_URL_MAX + 1) . ':' . $analysis['max']['url_length'],
),
) ),
) );
?>
		
	<?php 
WSKO_Class_Template::render_panel( array(
    'type'   => 'custom',
    'title'  => __( 'Pages', 'wsko' ),
    'col'    => 'col-sm-12 col-xs-12',
    'custom' => WSKO_Class_Template::render_table(
    $header_link_table,
    array(),
    array(
    'id'     => 'wsko_onpage_analysis_permalink_table',
    'order'  => $order,
    'ajax'   => array(
    'action' => 'wsko_table_onpage',
    'arg'    => 'links',
),
    'filter' => $filter_link_table,
),
    true
),
) );
?>
</div>