<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}

if ( current_user_can( 'manage_options' ) ) {
    $post_types = WSKO_Class_Helper::get_public_post_types( 'objects' );
    $widget = ( isset( $template_args['widget'] ) ? $template_args['widget'] : false );
    $collapsed = ( isset( $template_args['collapsed'] ) ? $template_args['collapsed'] : false );
    
    if ( !$widget ) {
        ?><div class="bsu-panel panel panel-default onpage-analysis-config-wrapper">
		<?php 
        
        if ( !$collapsed ) {
            ?>
			<p class="panel-heading m0">Onpage Analysis Settings</p><?php 
        } else {
            ?>
			<div class="panel-heading m0"><a data-toggle="collapse" class="dark" data-parent="#wsko_setup_accordion" href="#onpage_settings"><i class="fa fa-angle-down fa-fw mr5"></i>Onpage Analysis Settings</a></div><?php 
        }
        
        ?>	
		<div id="onpage_settings" class="panel-body <?php 
        echo  ( $collapsed ? 'panel-collapse collapse' : '' ) ;
        ?>">
	<?php 
    }
    
    ?>
			<?php 
    
    if ( defined( 'WSKO_DEV_SWITCH' ) && WSKO_DEV_SWITCH ) {
        ?>
				<div class="row form-group">
					<div class="col-sm-3">
						<p class="m0">Controls</p>
					</div>
					<div class="col-sm-9">
						<label>
							<?php 
        WSKO_Class_Template::render_ajax_button(
            'Regenerate Analysis',
            'regen_onpage_analysis',
            array(),
            array(
            'no_reload' => true,
            'alert'     => 'Do you really want to regenerate your Onpage report?',
        )
        );
        ?>
						</label>
					</div>
				</div>
			<?php 
    }
    
    ?>
			<div class="row wsko-onpage-exclude-post-types form-group" style="overflow-y:auto;max-height:130px;">
				<div class="col-sm-3 col-xs-12">
					<p class="m0"><b>Exclude</b> post types from Onpage Analysis</p>
					<small class="text-off">Select Post Types to exclude from 'Onpage Analysis'</small>
				</div>
				<div class="col-sm-9 col-xs-12">
					<div class="row">
						<?php 
    $excluded = explode( ',', WSKO_Class_Core::get_setting( 'onpage_exclude_post_types' ) );
    foreach ( $post_types as $pt ) {
        ?><div class="col-md-3">
								<label><input class="form-control wsko-ajax-input" type="checkbox" <?php 
        echo  ( in_array( $pt->name, $excluded ) ? 'checked="checked"' : '' ) ;
        ?> data-wsko-target="settings" data-wsko-setting="onpage_exclude_post_types" data-multi-parent=".wsko-onpage-exclude-post-types" value="<?php 
        echo  $pt->name ;
        ?>"><?php 
        echo  $pt->label ;
        ?> <span class="settings-sub font-unimportant"><?php 
        echo  $pt->name ;
        ?></span></label>
							</div><?php 
    }
    ?>
					</div>	
				</div>	
			</div>
			<?php 
    
    if ( WSKO_Class_Core::is_configured() ) {
        ?><div class="row form-group" style="overflow-y:auto;max-height:130px;">
					<div class="col-sm-3">
						<p class="m0">Onpage Analysis - <b>Exclude</b> posts</p>
						<small class="text-off">Exclude single posts from Onpage Analysis</small>
					</div>
					<div class="col-sm-9">
						<input class="form-control wsko-ajax-input" type="text" data-wsko-target="settings" data-wsko-setting="onpage_exclude_posts" value="<?php 
        echo  WSKO_Class_Core::get_setting( 'onpage_exclude_posts' ) ;
        ?>" placeholder="Post IDs (1,12,355)">
					</div>	
				</div><?php 
    }
    
    ?>
			<div class="row wsko-onpage-post-types-h1-title form-group" style="overflow-y:auto;max-height:130px;">
				<div class="col-sm-3 col-xs-12">
					<p>Post title is used as H1</p>
					<p class="small text-off">Select post types where the post title is used as the H1-Heading of your content.</p>
				</div>
				<div class="col-sm-9 col-xs-12">
					<div class="row">
						<?php 
    $included = explode( ',', WSKO_Class_Core::get_setting( 'onpage_title_h1' ) );
    foreach ( $post_types as $pt ) {
        ?><div class="col-md-3">
								<label><input class="form-control wsko-ajax-input" type="checkbox" <?php 
        echo  ( in_array( $pt->name, $included ) ? 'checked="checked"' : '' ) ;
        ?> data-wsko-target="settings" data-wsko-setting="onpage_title_h1" data-multi-parent=".wsko-onpage-post-types-h1-title" value="<?php 
        echo  $pt->name ;
        ?>"><?php 
        echo  $pt->label ;
        ?> <span class="settings-sub font-unimportant"><?php 
        echo  $pt->name ;
        ?></span></label>
							</div><?php 
    }
    ?>
					</div>	
				</div>	
			</div>			
			<?php 
    /*
    			<div class="row form-group no-border">
    				<div class="col-sm-4">
    					<p class="m0">Content Optimizer Timespan</p>
    					<small class="text-off">Select time range to consider, when displaying content optimizer values.</small>
    				</div>
    				<div class="col-sm-8">
    					<span>
    						<input class="form-control wsko-ajax-input" type="number" name="content_optimizer_time" value="<?=WSKO_Class_Core::get_setting('content_optimizer_time')?>" data-wsko-target="settings" data-wsko-setting="content_optimizer_time" placeholder="Default: 27 (days)">
    					</span>
    				</div>
    			</div>			
    			
    			<div class="row form-group">
    				<div class="col-sm-3">
    					<p class="m0">Onpage Analysis - Interval</p>
    					<small class="text-off">Set the interval in days after which the Onpage Analysis should be regenerated.<br/>[1-30, default:7]</small>
    				</div>
    				<div class="col-sm-9">
    					<div class="row wsko-settings-include-post-types" style="overflow-y:auto;max-height:150px;margin:20px 0px;">
    						<div class="range-field">
    							<input type="range" class="wsko-ajax-input" type="number" value="<?=$onpage_analysis_interval?>" data-wsko-target="settings" data-wsko-setting="onpage_analysis_interval" min="1" max="30"/>
    							<p class="text"><?=$onpage_analysis_interval?></p>
    						</div>
    						<!--div class="wsko-ajax-input wsko-ajax-slider" type="number" value="<?=$onpage_analysis_interval?>" data-wsko-target="settings" data-wsko-setting="onpage_analysis_interval" data-min="1" data-max="30"></div-->
    					</div>
    				</div>
    			</div> */
    ?>
			<?php 
    $id = WSKO_Class_Helper::get_unique_id( 'wsko_onpage_crawl_remove_' );
    ?>
			<div id="<?php 
    echo  $id ;
    ?>">
				<?php 
    if ( (WSKO_Class_Core::is_configured() || !WSKO_Class_Core::get_option( 'start_with_onpage_crawl' )) && !wp_next_scheduled( 'wsko_onpage_analysis' ) ) {
        WSKO_Class_Template::render_ajax_button(
            'Start Onpage Crawl',
            'refresh_analysis',
            array(),
            array(
            'remove'    => '#' . $id,
            'class'     => 'button-primary',
            'no_reload' => !WSKO_Class_Core::is_configured(),
        )
        );
    }
    ?>
			</div>

	<?php 
    if ( !$widget ) {
        ?>
		</div>
	</div>
	<?php 
    }
} else {
    WSKO_Class_Template::render_notification( 'error', array(
        'msg' => 'Only Admins can edit API settings.',
    ) );
}
