<?php
if (!defined('ABSPATH')) exit;

if (current_user_can('manage_options'))
{
	$collapsed = isset($template_args['collapsed']) ? $template_args['collapsed'] : false;
	$is_configured = WSKO_Class_Core::is_configured();
	$has_first_report = WSKO_Class_Core::get_option('search_query_first_run');
	$ga_client_se = WSKO_Class_Search::get_ga_client_se();
	$ga_token_se = WSKO_Class_Search::get_se_token();
	$ga_site_ver = WSKO_Class_Search::get_site_verification();
	$ga_ov_domain = WSKO_Class_Search::get_search_data('override_domain');
	$ga_valid_se = false;
	/*if (WSKO_Class_Core::is_configured())
	{
		if (WSKO_Class_Core::get_option('search_query_first_run'))
			$ga_valid_se = !WSKO_Class_Search::check_se_access(true);
		else if ($ga_client_se && $ga_token_se)
			$ga_valid_se = true;
	}
	else
		$ga_valid_se = !WSKO_Class_Search::check_se_access(true);*/
		$ga_valid_se = !WSKO_Class_Core::get_option('search_query_first_run') && $ga_token_se ? true : !WSKO_Class_Search::check_se_access(!WSKO_Class_Core::is_configured());
	?><div class="wsko-settings-api-wrapper bsu-panel panel panel-default">
		<?php 
		WSKO_Class_Template::render_status_iconbar(array(
			array('condition' => $ga_client_se, 'text_t' => 'API loaded', 'text_f' => 'API could not be loaded!'),
			array('condition' => $ga_token_se, 'text_t' => 'Credentials provided', 'text_f' => 'No Credentials provided'),
			array('condition' => $ga_valid_se, 'text_t' => 'Permission granted', 'text_f' => 'Credentials invalid or insufficient permissions'),
		), array('class' => 'pull-right m10')); ?>
		
		<?php
		if (!$collapsed) { ?>
			<p class="panel-heading m0">Google Search Console API</p><?php 
		} else { ?>
			<div class="panel-heading m0"><a data-toggle="collapse" class="dark" data-parent="#wsko_setup_accordion" href="#search"><i class="fa fa-angle-down fa-fw mr5"></i>Google Search Console API</a></div><?php 
		} ?>

		<div id="search" class="panel-body <?=$collapsed ? 'panel-collapse collapse' : ''?>">
			<div class="wsko-settings-api-box">
				<div class="wsko-api-login-help-box" style="display:none;margin-bottom:10px">
				</div>
				<div class="wsko-api-login-help-box-custom" style="display:none;margin-bottom:10px">
				</div>
			<?php
				if ($ga_client_se)
				{
					if ($ga_token_se)
					{
						if ($ga_valid_se)
						{
							if ($is_configured)
							{
								if (!$has_first_report)
								{
									WSKO_Class_Template::render_notification('info', array('msg' => 'Your first report is being fetched, please be patient.', 'subnote' => 'Working on package '.intval(WSKO_Class_Core::get_option('search_query_first_run_step')).' out of 9 packages.'));
								}
							}
						}
						else
						{
							WSKO_Class_Template::render_notification('error', array('msg' => 'Your credentials are invalid or you have insufficient permissions.'));
							
						}
					}
				}
				if ($ga_client_se)
				{
					if ($ga_token_se)
					{
						?>
						<div class="row form-group">
							<div class="col-sm-3">
								<p class="m0">Controls</p>
							</div>
							<div class="col-sm-9"><?php
								if ($ga_valid_se)
								{
									if ($is_configured)
									{
										if ($has_first_report)
										{
											WSKO_Class_Template::render_recache_api_button('ga_search', array('title' => 'Update Keyword Cache', 'ajax_reload' => '.wsko-settings-api-wrapper'));
											WSKO_Class_Template::render_delete_api_cache_button('ga_search', array('title' => 'Clear Keyword Cache', 'ajax_reload' => '.wsko-settings-api-wrapper'));
										}
									}
									else
									{
										WSKO_Class_Template::render_notification('info', array('msg' => 'You are logged in! More controls will be available after setup.'));
									}
								}
								WSKO_Class_Template::render_revoke_api_button('ga_search', array('ajax_reload' => '.wsko-settings-api-wrapper')); ?>
							</div>
						</div><?php
					}
					else
					{
						$auth_url = WSKO_Class_Search::get_se_auth_url();
						if (!$auth_url)
						{
							WSKO_Class_Template::render_notification('error', array('msg' => 'Authentication URL could not be generated.'));
						}
						else
						{
							?>
							<div class="row form-group">
								<form class="wsko-admin-request-api-access" method="POST" data-nonce="<?=wp_create_nonce('wsko_request_api_access')?>" data-api="ga_search">
									<div class="col-sm-3">
										<p class="m0">Access Token</p>
									</div>
									<div class="col-sm-9">
										<input placeholder="Insert Access Token" class="form-control wsko-token-field mb10" type="text" name="code" autocomplete="off" required>
										<a class="wp-core-ui button" style="margin-bottom: 5px;" href="<?=$auth_url?>" target="_blank">Get Access Token</a>
										<input class="wsko-request-btn wp-core-ui button wsko-button-success" type="submit" value="Login">
									</div>
								</form>
							</div>
							<?php
						}
					}
					?>
					<div class="row form-group" style="padding: 0px; margin-bottom: 0px;">
						<div class="col-sm-12">
							<div class="wsko-collapse-wrapper">
								<p style="margin-bottom:10px;"><a href="#" class="wsko-collapse dark wsko-text-off wsko-mb-10">Not connected to Google Search Console yet?</a></p>
								<div class="wsko-collapse-content" style="max-height:0px;">						
									<div class="row form-group">
										<div class="col-sm-3">
											<p class="m0">Site Verification - HTML Tag</p>
											<small class="text-off">See <a target="_blank" href="https://support.google.com/webmasters/answer/35179?hl=de">Google Documentation</a> for more information.</small>
										</div>
										<div class="col-sm-9">
											<input class="wsko-ajax-input form-control" data-wsko-target="api_search" data-wsko-setting="site_verification" value="<?=$ga_site_ver?>">
											<small class="text-off">Insert your verification code to auto-create a HTML-Meta Tag.</small>
										</div>
									</div>
								</div>
							</div>
							<div class="wsko-collapse-wrapper">
								<p style="margin-bottom:10px;"><a href="#" class="wsko-collapse dark wsko-text-off wsko-mb-10">"<?=WSKO_Class_Helper::get_host_base()?>" is used to get your Search Console property. Correct domain? </a></p>
								<div class="wsko-collapse-content" style="max-height:0px;">						
									<div class="row form-group">
										<div class="col-sm-3">
											<p class="m0">Override Domain</p>
											<small class="text-off">If you can't connect to the Search API, check for discrepancies between the default domain and the actual property url in your Search Console.</small>
										</div>
										<div class="col-sm-9">
											<input class="wsko-ajax-input form-control" data-wsko-target="api_search" data-wsko-setting="override_domain" value="<?=$ga_ov_domain?>" placeholder="https://www.example.com/">
											<small class="text-off">Default: <?=WSKO_Class_Helper::get_host_base()?></small>
										</div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<?php
				}
				else
				{
					WSKO_Class_Template::render_notification('error', array('msg' => 'API could not be loaded. Another plugin may have loaded an earlier version of the Google Client API.'));
				}
				?>
			</div>
		</div>
	</div><?php
} else {
	WSKO_Class_Template::render_notification('error', array('msg' => 'Only Admins can edit API settings.'));
} ?>
