<?php
if (!defined('ABSPATH')) exit;

if (current_user_can('manage_options'))
{
	$collapsed = isset($template_args['collapsed']) ? $template_args['collapsed'] : false;
	$social_client_tw = WSKO_Class_Social::get_twitter_client();
	$social_profile_tw = WSKO_Class_Social::get_twitter_profile();
	$social_valid_tw = !WSKO_Class_Social::check_twitter_access(true);
	?><div class="wsko-settings-api-wrapper bsu-panel panel panel-default">
		<?php
			WSKO_Class_Template::render_status_iconbar(array(
			array('condition' => $social_client_tw, 'text_t' => 'API loaded', 'text_f' => 'API could not be loaded!'),
			array('condition' => $social_profile_tw, 'text_t' => 'Credentials provided', 'text_f' => 'No Credentials provided'),
			array('condition' => $social_valid_tw, 'text_t' => 'Permission granted', 'text_f' => 'Credentials invalid or insufficient permissions'),
		), array('class' => 'pull-right m10')); ?>
		
		<?php
		if (!$collapsed) { ?>
			<p class="panel-heading m0">Twitter API</p><?php 
		} else { ?>
			<div class="panel-heading m0"><a data-toggle="collapse" class="dark" data-parent="#wsko_setup_accordion" href="#twitter"><i class="fa fa-angle-down fa-fw mr5"></i>Twitter API</a></div><?php 
		} ?>

		<div id="twitter" class="panel-body <?=$collapsed ? 'panel-collapse collapse' : ''?>">
			<div class="wsko-settings-api-box"><?php
				if ($social_client_tw)
				{
					if ($social_profile_tw)
					{
						if (!$social_valid_tw)
						{
							WSKO_Class_Template::render_notification('error', array('msg' => 'Your credentials are invalid or you have insufficient permissions.'));
						}
					}
					?><div class="wsko-api-twitter-set-profile">
						<div class="row form-group">
							<div class="col-sm-3">
								<p class="m0">Twitter User</p>
							</div>
							<div class="col-sm-9">
								<input class="wsko-api-twitter-set-profile-value form-control mb10" value="<?=$social_profile_tw?>" placeholder="Your twitter page username">
								<a href="#" class="button wsko-api-twitter-set-profile-btn" data-nonce="<?=wp_create_nonce('wsko_set_twitter_profile')?>">Set as Profile</a>
							</div>
						</div>
						<?php
						if ($social_profile_tw)
							{
								WSKO_Class_Template::render_recache_api_button('social_twitter', array('ajax_reload' => '.wsko-settings-api-wrapper'));
							}
						?>	
					</div><?php
				}
				else
				{
					WSKO_Class_Template::render_notification('error', array('msg' => 'API could not be loaded. Another plugin may have loaded an earlier version of the Twitter API.'));
				}
				?>
			</div>
		</div>	
	</div><?php
} else {
	WSKO_Class_Template::render_notification('error', array('msg' => 'Only Admins can edit API settings.'));
} ?>