<?php

//WSKO_Class_Template::render_notification('info', array('msg' => 'Google recently shortened the meta description length to approximately 160 characters. We recommend you to update your meta descriptions to get the best results.', 'discardable' => 'onpage_meta_desc_length_16_05_2018'));
if ( !WSKO_Class_Helper::is_php_func_enabled( 'set_time_limit' ) ) {
    WSKO_Class_Template::render_notification( 'error', array(
        'msg'     => 'The critical function "set_time_limit" has been disabled on your server. This can lead to not finished scripts, corrupt data and thus endless loading.',
        'subnote' => "This usually happens on shared hosting providers due to their systems structure. Please contact your website administrator.",
    ) );
}

if ( wsko_fs()->is_premium() ) {
    if ( !wsko_fs()->can_use_premium_code() ) {
        WSKO_Class_Template::render_notification( 'warning', array(
            'msg' => 'Your license has timed out. <a href="' . WSKO_Controller_Account::get_link() . '">View Account</a>',
        ) );
    }
} else {
    
    if ( wsko_fs()->can_use_premium_code() ) {
        $user = wsko_fs()->get_user();
        WSKO_Class_Template::render_notification( 'warning', array(
            'msg'     => 'You are using the Free version with a Premium license. Please download the Premium version to access the full functionality of BAVOKO SEO Tools. <a href="' . WSKO_Controller_Account::get_link() . '">View Account</a>',
            'subnote' => 'A mail with further information was sent to ' . $user->email,
        ) );
    }

}

if ( wsko_fs()->is_premium() ) {
    if ( wsko_fs()->_get_license() && !wsko_fs()->get_plan() ) {
        WSKO_Class_Template::render_notification( 'warning', array(
            'msg' => 'Your license is missing a valid premium plan. Try resyncing the license in your <a href="' . WSKO_Controller_Account::get_link() . '">Account</a> panel.',
        ) );
    }
}
$wsko_data = WSKO_Class_Core::get_data();
if ( isset( $wsko_data['version_pre'] ) && $wsko_data['version_pre'] && version_compare( $wsko_data['version_pre'], '2.1', '<' ) ) {
    WSKO_Class_Template::render_notification( 'warning', array(
        'msg'  => 'BST 2.1 has come with many core changes. To ensure a bug free experience we recommend reseting your environment. ' . WSKO_Class_Template::render_ajax_button(
        'Reset',
        'reset_configuration',
        array(
        'delete_metas'   => false,
        'delete_cache'   => false,
        'delete_backups' => false,
    ),
        array(),
        true
    ),
        'note' => 'You will need to reconfigure the plugin afterwards.',
    ) );
}