<?php
/*
Plugin Name: 	BAVOKO SEO Tools
Plugin URI: 	http://www.bavoko.tools/
Description: 	The Most Comprehensive All-in-One WordPress SEO Plugin!
Version: 		2.1.3
Author: 		BAVOKO Tools
Text Domain: 	wsko
Domain Path: 	/languages
Author URI: 	http://www.bavoko.tools/
License:     	GPL2 or later

@fs_premium_only /includes/datatables/datatables.buttons.min.css, /includes/datatables/datatables.buttons.min.js, /includes/datatables/datatables.buttons.flash.min.js, /includes/datatables/datatables.buttons.html5.min.js, /includes/datatables/datatables.buttons.print.min.js, /admin/templates/performance/, /admin/templates/backlinks/, /admin/templates/content-optimizer/template-co-backlinks.php, /admin/templates/content-optimizer/template-co-linking.php, /admin/templates/content-optimizer/template-co-performance.php, /admin/templates/search/page-competitors.php, /admin/templates/search/page-research.php, /admin/templates/search/view-research-widget.php, /admin/templates/search/view-keyword-research-report.php, /admin/templates/tools/page-linking.php, /admin/templates/onpage/page-canon.php, /admin/templates/onpage/page-index.php, /admin/templates/onpage/page-resources.php, /admin/templates/settings/view-api-analytics.php, /admin/templates/settings/view-premium-quota.php, /admin/templates/settings/view-reporting.php, /admin/templates/setup/view-premium-setup.php, /admin/templates/premium/view-premium-dashboard.php, /admin/templates/premium/template-premium-quota.php, /admin/controller/controller.backlinks.php, /admin/controller/controller.performance.php, /classes/class.premium.php, /templates/template-onpage-crawl-error.php
*/
/*
BAVOKO SEO Tools is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
any later version.
 
BAVOKO SEO Tools is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
*/
if (!defined('ABSPATH')) exit;

if (!function_exists('wsko_fs'))
{
	define('WSKO_VERSION', '2.1.3');

	global $wpdb, $wsko_plugin_path, $wsko_plugin_url;
	$wsko_plugin_path = dirname(__FILE__) . '/';
	$wsko_plugin_url = plugins_url('', __FILE__) . '/';

	require_once($wsko_plugin_path . 'classes/class.core.php');
	require_once($wsko_plugin_path . 'classes/class.freemius.php');
	WSKO_Class_Core::init_classes();
	WSKO_Class_Freemius::init_get_freemius();

	function wsko_install_plugin()
	{
		WSKO_Class_Core::init_classes(true);
		
		if (WSKO_Class_Core::is_configured())
			WSKO_Class_Crons::register_cronjobs();
		WSKO_Class_Core::install();
		//update_option('wsko_do_activation_redirect', true);
	}
	register_activation_hook(__FILE__, 'wsko_install_plugin');

	function wsko_deinstall_plugin()
	{
		WSKO_Class_Core::init_classes(true);
		
		WSKO_Class_Core::deinstall();
	}
	register_deactivation_hook(__FILE__, 'wsko_deinstall_plugin');

	function wsko_update_plugin($upgrader_object, $options)
	{
		WSKO_Class_Core::init_classes(true);
		
		$current_plugin_path_name = plugin_basename(__FILE__);

		if ($options['action'] == 'update' && $options['type'] == 'plugin')
		{
			if ($options['plugins'])
			{
				foreach($options['plugins'] as $pl)
				{
					if ($pl == $current_plugin_path_name)
					{
						WSKO_Class_Core::update();
						$wsko_data = WSKO_Class_Core::get_data();
						if ((isset($wsko_data['version']) && $wsko_data['version'] && version_compare($wsko_data['version'], "2.0", "<")))
							update_option('wsko_do_activation_redirect', true);
					}
				}
			}
		}
	}
	add_action('upgrader_process_complete', 'wsko_update_plugin', 10, 2);

	function wsko_activation_redirect($plugin)
	{
		if (get_option('wsko_do_activation_redirect') && !WSKO_Class_Core::get_option('activation_page_shown'))
		{
			WSKO_Class_Core::save_option('activation_page_shown', true);
			delete_option('wsko_do_activation_redirect');
			wp_redirect(WSKO_Controller_Info::get_link());
			exit();
		}
	}
	add_action('admin_init', 'wsko_activation_redirect');
}
?>